// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _BOPAlgo_Section_HeaderFile
#define _BOPAlgo_Section_HeaderFile

#include <Standard.hxx>
#include <Standard_DefineAlloc.hxx>
#include <Standard_Macro.hxx>

#include <BOPAlgo_Builder.hxx>
#include <BOPCol_BaseAllocator.hxx>
class BOPAlgo_PaveFiller;
class TopTools_ListOfShape;
class TopoDS_Shape;



//! The algorithm to build a Secton between the arguments.
//! The Section consists of vertices and edges.
//! The Section contains:
//! 1. new vertices that are subjects of V/V, E/E, E/F, F/F interferences
//! 2. vertices that are subjects of V/E, V/F interferences
//! 3. new edges that are subjects of F/F interferences
//! 4. edges that are Common Blocks
class BOPAlgo_Section  : public BOPAlgo_Builder
{
public:

  DEFINE_STANDARD_ALLOC

  
  //! Empty constructor
  Standard_EXPORT BOPAlgo_Section();
Standard_EXPORT virtual ~BOPAlgo_Section();
  
  //! Empty constructor
  //!
  //! protected methods
  Standard_EXPORT BOPAlgo_Section(const BOPCol_BaseAllocator& theAllocator);
  
  Standard_EXPORT virtual   void BuildSection() ;
  
  //! Returns the  list of shapes generated from the
  //! shape theS.
  Standard_EXPORT virtual  const  TopTools_ListOfShape& Generated (const TopoDS_Shape& theS) ;




protected:

  
  Standard_EXPORT virtual   void CheckData() ;
  
  //! Performs calculations using prepared Filler
  //! object <thePF>
  Standard_EXPORT virtual   void PerformInternal1 (const BOPAlgo_PaveFiller& thePF) ;




private:





};







#endif // _BOPAlgo_Section_HeaderFile
