// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _BOPAlgo_ShellSplitter_HeaderFile
#define _BOPAlgo_ShellSplitter_HeaderFile

#include <Standard.hxx>
#include <Standard_DefineAlloc.hxx>
#include <Standard_Macro.hxx>

#include <BOPCol_ListOfShape.hxx>
#include <BOPTools_ListOfConnexityBlock.hxx>
#include <BOPAlgo_Algo.hxx>
#include <BOPCol_BaseAllocator.hxx>
#include <BOPTools_ConnexityBlock.hxx>
class TopoDS_Shape;



//! The class provides the splitting of the set of connected faces
//! on separate loops
class BOPAlgo_ShellSplitter  : public BOPAlgo_Algo
{
public:

  DEFINE_STANDARD_ALLOC

  
  //! empty constructor
  Standard_EXPORT BOPAlgo_ShellSplitter();
Standard_EXPORT virtual ~BOPAlgo_ShellSplitter();
  
  //! constructor
  Standard_EXPORT BOPAlgo_ShellSplitter(const BOPCol_BaseAllocator& theAllocator);
  
  //! adds a face <theS> to process
  Standard_EXPORT   void AddStartElement (const TopoDS_Shape& theS) ;
  
  //! return the faces to process
  Standard_EXPORT  const  BOPCol_ListOfShape& StartElements()  const;
  
  //! performs the algorithm
  Standard_EXPORT virtual   void Perform() ;
  
  //! returns the loops
  Standard_EXPORT  const  BOPCol_ListOfShape& Shells()  const;
  
  Standard_EXPORT static   void SplitBlock (BOPTools_ConnexityBlock& theCB) ;




protected:

  
  Standard_EXPORT   void MakeConnexityBlocks() ;
  
  Standard_EXPORT   void MakeShells() ;


  BOPCol_ListOfShape myStartShapes;
  BOPCol_ListOfShape myShells;
  BOPTools_ListOfConnexityBlock myLCB;


private:





};







#endif // _BOPAlgo_ShellSplitter_HeaderFile
