// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _BRepCheck_Solid_HeaderFile
#define _BRepCheck_Solid_HeaderFile

#include <Standard.hxx>
#include <Standard_DefineHandle.hxx>
#include <Handle_BRepCheck_Solid.hxx>

#include <BRepCheck_Result.hxx>
class TopoDS_Solid;
class TopoDS_Shape;


//! The class is to check a solid.
class BRepCheck_Solid : public BRepCheck_Result
{

public:

  

  //! Constructor
  //! <theS> is the solid to check
  Standard_EXPORT BRepCheck_Solid(const TopoDS_Solid& theS);
  

  //! Checks the solid in context of
  //! the shape <theContextShape>
  Standard_EXPORT virtual   void InContext (const TopoDS_Shape& theContextShape) ;
  

  //! Checks the solid per se.
  //!
  //! The scan area is:
  //! 1.  Shells that overlaps each other
  //! Status:  BRepCheck_InvalidImbricationOfShells
  //!
  //! 2.  Detached parts of the solid (vertices, edges)
  //! that have non-internal orientation
  //! Status:  BRepCheck_BadOrientationOfSubshape
  //!
  //! 3.  For closed, non-internal shells:
  //! 3.1 Shells containing entities  of the solid that
  //! are outside towards the shells
  //! Status:  BRepCheck_SubshapeNotInShape
  //!
  //! 3.2 Shells that encloses other Shells
  //! (for non-holes)
  //! Status:  BRepCheck_EnclosedRegion
  Standard_EXPORT virtual   void Minimum() ;
  

  //! see the parent class for more details
  Standard_EXPORT virtual   void Blind() ;




  DEFINE_STANDARD_RTTI(BRepCheck_Solid)

protected:




private: 




};







#endif // _BRepCheck_Solid_HeaderFile
