// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _BRepLib_MakeShell_HeaderFile
#define _BRepLib_MakeShell_HeaderFile

#include <Standard.hxx>
#include <Standard_DefineAlloc.hxx>
#include <Standard_Macro.hxx>

#include <BRepLib_ShellError.hxx>
#include <BRepLib_MakeShape.hxx>
#include <Handle_Geom_Surface.hxx>
#include <Standard_Boolean.hxx>
#include <Standard_Real.hxx>
class StdFail_NotDone;
class Geom_Surface;
class TopoDS_Shell;


//! Provides methos to build shells.
//!
//! Build a shell from a set of faces.
//! Build untied shell from a non C2 surface
//! splitting it into C2-continuous parts.
class BRepLib_MakeShell  : public BRepLib_MakeShape
{
public:

  DEFINE_STANDARD_ALLOC

  
  //! Not done.
  Standard_EXPORT BRepLib_MakeShell();
  
  Standard_EXPORT BRepLib_MakeShell(const Handle(Geom_Surface)& S, const Standard_Boolean Segment = Standard_False);
  
  Standard_EXPORT BRepLib_MakeShell(const Handle(Geom_Surface)& S, const Standard_Real UMin, const Standard_Real UMax, const Standard_Real VMin, const Standard_Real VMax, const Standard_Boolean Segment = Standard_False);
  
  //! Creates the shell from the surface  and the min-max
  //! values.
  Standard_EXPORT   void Init (const Handle(Geom_Surface)& S, const Standard_Real UMin, const Standard_Real UMax, const Standard_Real VMin, const Standard_Real VMax, const Standard_Boolean Segment = Standard_False) ;
  
  Standard_EXPORT   BRepLib_ShellError Error()  const;
  
  //! Returns the new Shell.
  Standard_EXPORT  const  TopoDS_Shell& Shell()  const;
Standard_EXPORT operator TopoDS_Shell() const;




protected:





private:



  BRepLib_ShellError myError;


};







#endif // _BRepLib_MakeShell_HeaderFile
