// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _BRepPrim_Cylinder_HeaderFile
#define _BRepPrim_Cylinder_HeaderFile

#include <Standard.hxx>
#include <Standard_DefineAlloc.hxx>
#include <Standard_Macro.hxx>

#include <Standard_Real.hxx>
#include <BRepPrim_Revolution.hxx>
class Standard_DomainError;
class gp_Ax2;
class gp_Pnt;
class TopoDS_Face;


//! Cylinder primitive.
class BRepPrim_Cylinder  : public BRepPrim_Revolution
{
public:

  DEFINE_STANDARD_ALLOC

  
  //! the STEP definition
  //! Position : center of a Face and Axis
  //! Radius : radius of cylinder
  //! Height : distance between faces
  //! on positive side
  //!
  //! Errors : Height < Resolution
  //! Radius < Resolution
  Standard_EXPORT BRepPrim_Cylinder(const gp_Ax2& Position, const Standard_Real Radius, const Standard_Real Height);
  
  //! infinite Cylinder at origin on Z negative
  Standard_EXPORT BRepPrim_Cylinder(const Standard_Real Radius);
  
  //! infinite Cylinder at Center on Z negative
  Standard_EXPORT BRepPrim_Cylinder(const gp_Pnt& Center, const Standard_Real Radius);
  
  //! infinite Cylinder at Axes on Z negative
  Standard_EXPORT BRepPrim_Cylinder(const gp_Ax2& Axes, const Standard_Real Radius);
  
  //! create a Cylinder  at origin on Z  axis, of
  //! height H and radius R
  //! Error  : Radius  < Resolution
  //! H < Resolution
  //! H negative
  Standard_EXPORT BRepPrim_Cylinder(const Standard_Real R, const Standard_Real H);
  
  //! same as above but at a given point
  Standard_EXPORT BRepPrim_Cylinder(const gp_Pnt& Center, const Standard_Real R, const Standard_Real H);
  
  //! The surface normal should be directed  towards the
  //! outside.
  Standard_EXPORT virtual   TopoDS_Face MakeEmptyLateralFace()  const;




protected:





private:

  
  Standard_EXPORT   void SetMeridian() ;


  Standard_Real myRadius;


};







#endif // _BRepPrim_Cylinder_HeaderFile
