// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _BRep_CurveOnSurface_HeaderFile
#define _BRep_CurveOnSurface_HeaderFile

#include <Standard.hxx>
#include <Standard_DefineHandle.hxx>
#include <Handle_BRep_CurveOnSurface.hxx>

#include <Handle_Geom2d_Curve.hxx>
#include <Handle_Geom_Surface.hxx>
#include <gp_Pnt2d.hxx>
#include <BRep_GCurve.hxx>
#include <Standard_Real.hxx>
#include <Standard_Boolean.hxx>
#include <Handle_BRep_CurveRepresentation.hxx>
class Geom2d_Curve;
class Geom_Surface;
class TopLoc_Location;
class gp_Pnt2d;
class gp_Pnt;
class BRep_CurveRepresentation;


//! Representation  of a  curve   by a   curve  in the
//! parametric space of a surface.
class BRep_CurveOnSurface : public BRep_GCurve
{

public:

  
  Standard_EXPORT BRep_CurveOnSurface(const Handle(Geom2d_Curve)& PC, const Handle(Geom_Surface)& S, const TopLoc_Location& L);
  
      void SetUVPoints (const gp_Pnt2d& P1, const gp_Pnt2d& P2) ;
  
      void UVPoints (gp_Pnt2d& P1, gp_Pnt2d& P2)  const;
  
  //! Computes the point at parameter U.
  Standard_EXPORT   void D0 (const Standard_Real U, gp_Pnt& P)  const;
  
  //! Returns True.
  Standard_EXPORT virtual   Standard_Boolean IsCurveOnSurface()  const;
  
  //! A curve in the parametric space of a surface.
  Standard_EXPORT virtual   Standard_Boolean IsCurveOnSurface (const Handle(Geom_Surface)& S, const TopLoc_Location& L)  const;
  
  Standard_EXPORT virtual  const  Handle(Geom_Surface)& Surface()  const;
  
  Standard_EXPORT virtual  const  Handle(Geom2d_Curve)& PCurve()  const;
  
  Standard_EXPORT virtual   void PCurve (const Handle(Geom2d_Curve)& C) ;
  
  //! Return a copy of this representation.
  Standard_EXPORT virtual   Handle(BRep_CurveRepresentation) Copy()  const;
  
  //! Recomputes any derived data after a modification.
  //! This is called when the range is modified.
  Standard_EXPORT virtual   void Update() ;




  DEFINE_STANDARD_RTTI(BRep_CurveOnSurface)

protected:


  gp_Pnt2d myUV1;
  gp_Pnt2d myUV2;


private: 


  Handle(Geom2d_Curve) myPCurve;
  Handle(Geom_Surface) mySurface;


};


#include <BRep_CurveOnSurface.lxx>





#endif // _BRep_CurveOnSurface_HeaderFile
