// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _DrawTrSurf_BSplineCurve_HeaderFile
#define _DrawTrSurf_BSplineCurve_HeaderFile

#include <Standard.hxx>
#include <Standard_DefineHandle.hxx>
#include <Handle_DrawTrSurf_BSplineCurve.hxx>

#include <Standard_Boolean.hxx>
#include <Draw_MarkerShape.hxx>
#include <Draw_Color.hxx>
#include <Standard_Integer.hxx>
#include <DrawTrSurf_Curve.hxx>
#include <Handle_Geom_BSplineCurve.hxx>
#include <Standard_Real.hxx>
#include <Handle_Draw_Drawable3D.hxx>
class Geom_BSplineCurve;
class Draw_Color;
class Draw_Display;
class Draw_Drawable3D;



class DrawTrSurf_BSplineCurve : public DrawTrSurf_Curve
{

public:

  

  //! creates a drawable BSpline curve from a BSpline curve of
  //! package Geom.
  Standard_EXPORT DrawTrSurf_BSplineCurve(const Handle(Geom_BSplineCurve)& C);
  

  //! creates a drawable BSpline curve from a BSpline curve of
  //! package Geom.
  Standard_EXPORT DrawTrSurf_BSplineCurve(const Handle(Geom_BSplineCurve)& C, const Draw_Color& CurvColor, const Draw_Color& PolesColor, const Draw_Color& KnotsColor, const Draw_MarkerShape KnotsShape, const Standard_Integer KnotsSize, const Standard_Boolean ShowPoles, const Standard_Boolean ShowKnots, const Standard_Integer Discret, const Standard_Real Deflection, const Standard_Integer DrawMode);
  
  Standard_EXPORT   void DrawOn (Draw_Display& dis)  const;
  
  Standard_EXPORT   void DrawOn (Draw_Display& dis, const Standard_Boolean ShowPoles, const Standard_Boolean ShowKnots)  const;
  
  Standard_EXPORT   void DrawOn (Draw_Display& dis, const Standard_Real U1, const Standard_Real U2, const Standard_Integer Pindex, const Standard_Boolean ShowPoles = Standard_True, const Standard_Boolean ShowKnots = Standard_True)  const;
  
  Standard_EXPORT   void ShowPoles() ;
  
  Standard_EXPORT   void ShowKnots() ;
  
  Standard_EXPORT   void ClearPoles() ;
  
  Standard_EXPORT   void ClearKnots() ;
  

  //! Returns in <Index> the index of the first pole  of the
  //! curve projected by the Display <D> at a distance lower
  //! than <Prec> from <X,Y>. If no pole  is found  index is
  //! set to 0, else index is always  greater than the input
  //! value of index.
  Standard_EXPORT   void FindPole (const Standard_Real X, const Standard_Real Y, const Draw_Display& D, const Standard_Real Prec, Standard_Integer& Index)  const;
  
  Standard_EXPORT   void FindKnot (const Standard_Real X, const Standard_Real Y, const Draw_Display& D, const Standard_Real Prec, Standard_Integer& Index)  const;
  
      void SetPolesColor (const Draw_Color& aColor) ;
  
      void SetKnotsColor (const Draw_Color& aColor) ;
  
      void SetKnotsShape (const Draw_MarkerShape Shape) ;
  
      Draw_MarkerShape KnotsShape()  const;
  
      Draw_Color KnotsColor()  const;
  
      Draw_Color PolesColor()  const;
  
  //! For variable copy.
  Standard_EXPORT virtual   Handle(Draw_Drawable3D) Copy()  const;




  DEFINE_STANDARD_RTTI(DrawTrSurf_BSplineCurve)

protected:




private: 


  Standard_Boolean drawPoles;
  Standard_Boolean drawKnots;
  Draw_MarkerShape knotsForm;
  Draw_Color knotsLook;
  Standard_Integer knotsDim;
  Draw_Color polesLook;


};


#include <DrawTrSurf_BSplineCurve.lxx>





#endif // _DrawTrSurf_BSplineCurve_HeaderFile
