// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _Expr_UnaryExpression_HeaderFile
#define _Expr_UnaryExpression_HeaderFile

#include <Standard.hxx>
#include <Standard_DefineHandle.hxx>
#include <Handle_Expr_UnaryExpression.hxx>

#include <Handle_Expr_GeneralExpression.hxx>
#include <Expr_GeneralExpression.hxx>
#include <Standard_Integer.hxx>
#include <Standard_Boolean.hxx>
#include <Handle_Expr_NamedUnknown.hxx>
class Expr_GeneralExpression;
class Standard_OutOfRange;
class Standard_NumericError;
class Expr_InvalidOperand;
class Expr_NamedUnknown;



class Expr_UnaryExpression : public Expr_GeneralExpression
{

public:

  
  //! Returns the operand used
     const  Handle(Expr_GeneralExpression)& Operand()  const;
  
  //! Sets the operand used
  //! Raises InvalidOperand if <exp> contains <me>.
  Standard_EXPORT   void SetOperand (const Handle(Expr_GeneralExpression)& exp) ;
  
  //! Returns the number of sub-expressions contained
  //! in <me> ( >= 0)
  Standard_EXPORT   Standard_Integer NbSubExpressions()  const;
  
  //! Returns the <I>-th sub-expression of <me>.
  //! Raises OutOfRange if <I> > NbSubExpressions(me)
  Standard_EXPORT  const  Handle(Expr_GeneralExpression)& SubExpression (const Standard_Integer I)  const;
  
  //! Does <me> contains NamedUnknown ?
  Standard_EXPORT   Standard_Boolean ContainsUnknowns()  const;
  
  //! Tests if <exp> is contained in <me>.
  Standard_EXPORT   Standard_Boolean Contains (const Handle(Expr_GeneralExpression)& exp)  const;
  
  //! Replaces all occurences of <var> with <with> in <me>
  //! Raises InvalidOperand if <with> contains <me>.
  Standard_EXPORT   void Replace (const Handle(Expr_NamedUnknown)& var, const Handle(Expr_GeneralExpression)& with) ;
  
  //! Returns a GeneralExpression after replacement of
  //! NamedUnknowns by an associated expression, and after
  //! values computation.
  Standard_EXPORT   Handle(Expr_GeneralExpression) Simplified()  const;




  DEFINE_STANDARD_RTTI(Expr_UnaryExpression)

protected:

  
  //! Sets the operand used during creation
  Standard_EXPORT   void CreateOperand (const Handle(Expr_GeneralExpression)& exp) ;



private: 


  Handle(Expr_GeneralExpression) myOperand;


};


#include <Expr_UnaryExpression.lxx>





#endif // _Expr_UnaryExpression_HeaderFile
