// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _Extrema_GenLocateExtPS_HeaderFile
#define _Extrema_GenLocateExtPS_HeaderFile

#include <Standard.hxx>
#include <Standard_DefineAlloc.hxx>
#include <Standard_Macro.hxx>

#include <Standard_Boolean.hxx>
#include <Standard_Real.hxx>
#include <Extrema_POnSurf.hxx>
class Standard_DomainError;
class StdFail_NotDone;
class gp_Pnt;
class Adaptor3d_Surface;
class Extrema_POnSurf;


//! With a close point, it calculates the distance
//! between a point and a surface.
//! This distance can be a minimum or a maximum.
class Extrema_GenLocateExtPS 
{
public:

  DEFINE_STANDARD_ALLOC

  
  Standard_EXPORT Extrema_GenLocateExtPS();
  
  //! Calculates the distance with a close point.
  //! The close point is defined by the parameter values
  //! U0 and V0.
  //! The function F(u,v)=distance(S(u,v),p) has an
  //! extremun when gradient(F)=0. The algorithm searchs
  //! a zero near the close point.
  Standard_EXPORT Extrema_GenLocateExtPS(const gp_Pnt& P, const Adaptor3d_Surface& S, const Standard_Real U0, const Standard_Real V0, const Standard_Real TolU, const Standard_Real TolV);
  
  //! Returns True if the distance is found.
  Standard_EXPORT   Standard_Boolean IsDone()  const;
  
  //! Returns the value of the extremum square distance.
  Standard_EXPORT   Standard_Real SquareDistance()  const;
  
  //! Returns the point of the extremum distance.
  Standard_EXPORT  const  Extrema_POnSurf& Point()  const;




protected:





private:



  Standard_Boolean myDone;
  Standard_Real mySqDist;
  Extrema_POnSurf myPoint;


};







#endif // _Extrema_GenLocateExtPS_HeaderFile
