// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _GCE2d_MakeMirror_HeaderFile
#define _GCE2d_MakeMirror_HeaderFile

#include <Standard.hxx>
#include <Standard_DefineAlloc.hxx>
#include <Standard_Macro.hxx>

#include <Handle_Geom2d_Transformation.hxx>
class Geom2d_Transformation;
class gp_Pnt2d;
class gp_Ax2d;
class gp_Lin2d;
class gp_Dir2d;


//! This class implements elementary construction algorithms for a
//! symmetrical transformation in 2D space about a point
//! or axis. The result is a Geom2d_Transformation transformation.
//! A MakeMirror object provides a framework for:
//! -   defining the construction of the transformation,
//! -   implementing the construction algorithm, and
//! -   consulting the result.
class GCE2d_MakeMirror 
{
public:

  DEFINE_STANDARD_ALLOC

  
  Standard_EXPORT GCE2d_MakeMirror(const gp_Pnt2d& Point);
  
  Standard_EXPORT GCE2d_MakeMirror(const gp_Ax2d& Axis);
  
  Standard_EXPORT GCE2d_MakeMirror(const gp_Lin2d& Line);
  
  //! Make a symetry transformation af axis defined by
  //! <Point> and <Direc>.
  Standard_EXPORT GCE2d_MakeMirror(const gp_Pnt2d& Point, const gp_Dir2d& Direc);
  
  //! Returns the constructed transformation.
  Standard_EXPORT  const  Handle(Geom2d_Transformation)& Value()  const;
  
  Standard_EXPORT  const  Handle(Geom2d_Transformation)& Operator()  const;
Standard_EXPORT operator Handle_Geom2d_Transformation() const;




protected:





private:



  Handle(Geom2d_Transformation) TheMirror;


};







#endif // _GCE2d_MakeMirror_HeaderFile
