// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _GeomInt_LineConstructor_HeaderFile
#define _GeomInt_LineConstructor_HeaderFile

#include <Standard.hxx>
#include <Standard_DefineAlloc.hxx>
#include <Standard_Macro.hxx>

#include <Standard_Boolean.hxx>
#include <TColStd_SequenceOfReal.hxx>
#include <Handle_Adaptor3d_TopolTool.hxx>
#include <Handle_GeomAdaptor_HSurface.hxx>
#include <Handle_IntPatch_Line.hxx>
#include <Standard_Integer.hxx>
#include <Standard_Real.hxx>
class Adaptor3d_TopolTool;
class GeomAdaptor_HSurface;
class StdFail_NotDone;
class Standard_OutOfRange;
class IntPatch_Line;


//! Splits given Line.
class GeomInt_LineConstructor 
{
public:

  DEFINE_STANDARD_ALLOC

  

  //! Empty constructor
    GeomInt_LineConstructor();
  

  //! Initializes me by two surfaces and corresponding
  //! tools which represent boundaries of surfaces
      void Load (const Handle(Adaptor3d_TopolTool)& D1, const Handle(Adaptor3d_TopolTool)& D2, const Handle(GeomAdaptor_HSurface)& S1, const Handle(GeomAdaptor_HSurface)& S2) ;
  

  //! Splits line
  Standard_EXPORT   void Perform (const Handle(IntPatch_Line)& L) ;
  

  //! Returns True if splitting was successful
      Standard_Boolean IsDone()  const;
  

  //! Returns number of splits
      Standard_Integer NbParts()  const;
  

  //! Return first and last parameters
  //! for given index of split
      void Part (const Standard_Integer I, Standard_Real& WFirst, Standard_Real& WLast)  const;




protected:

  
  Standard_EXPORT   void TreatCircle (const Handle(IntPatch_Line)& aLine, const Standard_Real aTol) ;




private:



  Standard_Boolean done;
  TColStd_SequenceOfReal seqp;
  Handle(Adaptor3d_TopolTool) myDom1;
  Handle(Adaptor3d_TopolTool) myDom2;
  Handle(GeomAdaptor_HSurface) myHS1;
  Handle(GeomAdaptor_HSurface) myHS2;


};


#include <GeomInt_LineConstructor.lxx>





#endif // _GeomInt_LineConstructor_HeaderFile
