// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _GeomLib_DenominatorMultiplier_HeaderFile
#define _GeomLib_DenominatorMultiplier_HeaderFile

#include <Standard.hxx>
#include <Standard_DefineAlloc.hxx>
#include <Standard_Macro.hxx>

#include <Handle_Geom_BSplineSurface.hxx>
#include <TColStd_Array1OfReal.hxx>
#include <Standard_Real.hxx>
class Geom_BSplineSurface;
class Standard_OutOfRange;
class Standard_ConstructionError;
class TColStd_Array1OfReal;


//! this defines an evaluator for a function of 2 variables
//! that will be used by CancelDenominatorDerivative in one
//! direction.
class GeomLib_DenominatorMultiplier 
{
public:

  DEFINE_STANDARD_ALLOC

  
  //! if the surface is rational this will define the evaluator
  //! of a real function of 2 variables a(u,v) such that
  //! if we define a new surface by :
  //! a(u,v) * N(u,v)
  //! NewF(u,v) = ----------------
  //! a(u,v) * D(u,v)
  Standard_EXPORT GeomLib_DenominatorMultiplier(const Handle(Geom_BSplineSurface)& Surface, const TColStd_Array1OfReal& KnotVector);
  
  //! Returns the value of
  //! a(UParameter,VParameter)=
  //!
  //! H0(UParameter)/Denominator(Umin,Vparameter)
  //!
  //! D Denominator(Umin,Vparameter)
  //! - ------------------------------[H1(u)]/(Denominator(Umin,Vparameter)^2)
  //! D U
  //!
  //! + H3(UParameter)/Denominator(Umax,Vparameter)
  //!
  //! D Denominator(Umax,Vparameter)
  //! - ------------------------------[H2(u)]/(Denominator(Umax,Vparameter)^2)
  //! D U
  Standard_EXPORT   Standard_Real Value (const Standard_Real UParameter, const Standard_Real VParameter)  const;




protected:





private:



  Handle(Geom_BSplineSurface) mySurface;
  TColStd_Array1OfReal myKnotFlatVector;


};







#endif // _GeomLib_DenominatorMultiplier_HeaderFile
