// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _GeomTools_HeaderFile
#define _GeomTools_HeaderFile

#include <Standard.hxx>
#include <Standard_DefineAlloc.hxx>
#include <Standard_Macro.hxx>

#include <Handle_Geom_Surface.hxx>
#include <Standard_OStream.hxx>
#include <Standard_IStream.hxx>
#include <Handle_Geom_Curve.hxx>
#include <Handle_Geom2d_Curve.hxx>
#include <Handle_GeomTools_UndefinedTypeHandler.hxx>
#include <Standard_Real.hxx>
class Geom_Surface;
class Geom_Curve;
class Geom2d_Curve;
class GeomTools_UndefinedTypeHandler;
class GeomTools_UndefinedTypeHandler;
class GeomTools_SurfaceSet;
class GeomTools_CurveSet;
class GeomTools_Curve2dSet;


//! The GeomTools package provides  utilities for Geometry.
//!
//! *  SurfaceSet,  CurveSet, Curve2dSet  : Tools used
//! for dumping, writing and reading.
//!
//! * Methods to dump, write, read curves and surfaces.
class GeomTools 
{
public:

  DEFINE_STANDARD_ALLOC

  
  //! A set of Curves from Geom2d.
  //! Dumps the surface on the stream.
  Standard_EXPORT static   void Dump (const Handle(Geom_Surface)& S, Standard_OStream& OS) ;
  
  //! Writes the surface on the stream.
  Standard_EXPORT static   void Write (const Handle(Geom_Surface)& S, Standard_OStream& OS) ;
  
  //! Reads the surface from the stream.
  Standard_EXPORT static   void Read (Handle(Geom_Surface)& S, Standard_IStream& IS) ;
  
  //! Dumps the Curve on the stream.
  Standard_EXPORT static   void Dump (const Handle(Geom_Curve)& C, Standard_OStream& OS) ;
  
  //! Writes the Curve on the stream.
  Standard_EXPORT static   void Write (const Handle(Geom_Curve)& C, Standard_OStream& OS) ;
  
  //! Reads the Curve from the stream.
  Standard_EXPORT static   void Read (Handle(Geom_Curve)& C, Standard_IStream& IS) ;
  
  //! Dumps the Curve on the stream.
  Standard_EXPORT static   void Dump (const Handle(Geom2d_Curve)& C, Standard_OStream& OS) ;
  
  //! Writes the Curve on the stream.
  Standard_EXPORT static   void Write (const Handle(Geom2d_Curve)& C, Standard_OStream& OS) ;
  
  //! Reads the Curve from the stream.
  Standard_EXPORT static   void Read (Handle(Geom2d_Curve)& C, Standard_IStream& IS) ;
  
  Standard_EXPORT static   void SetUndefinedTypeHandler (const Handle(GeomTools_UndefinedTypeHandler)& aHandler) ;
  
  Standard_EXPORT static   Handle(GeomTools_UndefinedTypeHandler) GetUndefinedTypeHandler() ;
  
  //! Reads the Standard_Real value from the stream. Zero is read
  //! in case of error
  Standard_EXPORT static   void GetReal (Standard_IStream& IS, Standard_Real& theValue) ;




protected:





private:




friend class GeomTools_UndefinedTypeHandler;
friend class GeomTools_SurfaceSet;
friend class GeomTools_CurveSet;
friend class GeomTools_Curve2dSet;

};







#endif // _GeomTools_HeaderFile
