// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _Geom_Axis1Placement_HeaderFile
#define _Geom_Axis1Placement_HeaderFile

#include <Standard.hxx>
#include <Standard_DefineHandle.hxx>
#include <Handle_Geom_Axis1Placement.hxx>

#include <Geom_AxisPlacement.hxx>
#include <Handle_Geom_Geometry.hxx>
class gp_Ax1;
class gp_Pnt;
class gp_Dir;
class gp_Trsf;
class Geom_Geometry;


//! Describes an axis in 3D space.
//! An axis is defined by:
//! - its origin, also termed the "Location point" of the axis,
//! - its unit vector, termed the "Direction" of the axis.
//! Note: Geom_Axis1Placement axes provide the
//! same kind of "geometric" services as gp_Ax1 axes
//! but have more complex data structures. The
//! geometric objects provided by the Geom package
//! use gp_Ax1 objects to include axes in their data
//! structures, or to define an axis of symmetry or axis of rotation.
//! Geom_Axis1Placement axes are used in a context
//! where they can be shared by several objects
//! contained inside a common data structure.
class Geom_Axis1Placement : public Geom_AxisPlacement
{

public:

  
  //! Returns a transient copy of A1.
  Standard_EXPORT Geom_Axis1Placement(const gp_Ax1& A1);
  

  //! P is the origin of the axis placement and V is the direction
  //! of the axis placement.
  Standard_EXPORT Geom_Axis1Placement(const gp_Pnt& P, const gp_Dir& V);
  
  //! Returns a non transient copy of <me>.
  Standard_EXPORT  const  gp_Ax1& Ax1()  const;
  
  //! Reverses the direction of the axis placement.
  Standard_EXPORT   void Reverse() ;
  
  //! Returns a copy of <me> reversed.
  Standard_EXPORT   Handle(Geom_Axis1Placement) Reversed()  const;
  
  //! Assigns V to the unit vector of this axis.
  Standard_EXPORT   void SetDirection (const gp_Dir& V) ;
  
  //! Applies the transformation T to this axis.
  Standard_EXPORT   void Transform (const gp_Trsf& T) ;
  
  //! Creates a new object, which is a copy of this axis.
  Standard_EXPORT   Handle(Geom_Geometry) Copy()  const;




  DEFINE_STANDARD_RTTI(Geom_Axis1Placement)

protected:




private: 




};







#endif // _Geom_Axis1Placement_HeaderFile
