// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _Graphic3d_ArrayOfSegments_HeaderFile
#define _Graphic3d_ArrayOfSegments_HeaderFile

#include <Standard.hxx>
#include <Standard_DefineHandle.hxx>
#include <Handle_Graphic3d_ArrayOfSegments.hxx>

#include <Graphic3d_ArrayOfPrimitives.hxx>
#include <Standard_Integer.hxx>
#include <Standard_Boolean.hxx>


//! Contains segments array definition
class Graphic3d_ArrayOfSegments : public Graphic3d_ArrayOfPrimitives
{

public:

  
  //! Creates an array of segments,
  //! a segment can be filled as:
  //! 1) creating a set of segments defined with his vertexs.
  //! i.e:
  //! myArray = Graphic3d_ArrayOfSegments(4)
  //! myArray->AddVertex(x1,y1,z1)
  //! ....
  //! myArray->AddVertex(x4,y4,z4)
  //! 2) creating a set of indexed segments defined with his vertex
  //! ans edges.
  //! i.e:
  //! myArray = Graphic3d_ArrayOfSegments(4,0,8)
  //! myArray->AddVertex(x1,y1,z1)
  //! ....
  //! myArray->AddVertex(x4,y4,z4)
  //! myArray->AddEdge(1)
  //! myArray->AddEdge(2)
  //! myArray->AddEdge(3)
  //! myArray->AddEdge(4)
  //! myArray->AddEdge(2)
  //! myArray->AddEdge(4)
  //! myArray->AddEdge(1)
  //! myArray->AddEdge(3)
  //!
  //! <maxVertexs> defined the maximun allowed vertex number in the array.
  //! <maxEdges> defined the maximun allowed edge number in the array.
  //! Warning:
  //! When <hasVColors> is TRUE , you must use only
  //! AddVertex(Point,Color) method
  Standard_EXPORT Graphic3d_ArrayOfSegments(const Standard_Integer maxVertexs, const Standard_Integer maxEdges = 0, const Standard_Boolean hasVColors = Standard_False);




  DEFINE_STANDARD_RTTI(Graphic3d_ArrayOfSegments)

protected:




private: 




};







#endif // _Graphic3d_ArrayOfSegments_HeaderFile
