// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _IFSelect_DispPerSignature_HeaderFile
#define _IFSelect_DispPerSignature_HeaderFile

#include <Standard.hxx>
#include <Standard_DefineHandle.hxx>
#include <Handle_IFSelect_DispPerSignature.hxx>

#include <Handle_IFSelect_SignCounter.hxx>
#include <IFSelect_Dispatch.hxx>
#include <Standard_CString.hxx>
#include <Standard_Boolean.hxx>
#include <Standard_Integer.hxx>
class IFSelect_SignCounter;
class Interface_InterfaceError;
class TCollection_AsciiString;
class Interface_Graph;
class IFGraph_SubPartsIterator;


//! A DispPerSignature sorts input Entities according to a
//! Signature : it works with a SignCounter to do this.
class IFSelect_DispPerSignature : public IFSelect_Dispatch
{

public:

  
  //! Creates a DispPerSignature with no SignCounter (by default,
  //! produces only one packet)
  Standard_EXPORT IFSelect_DispPerSignature();
  
  //! Returns the SignCounter used for splitting
  Standard_EXPORT   Handle(IFSelect_SignCounter) SignCounter()  const;
  
  //! Sets a SignCounter for sort
  //! Remark : it is set to record lists of entities, not only counts
  Standard_EXPORT   void SetSignCounter (const Handle(IFSelect_SignCounter)& sign) ;
  
  //! Returns the name of the SignCounter, which caracterises the
  //! sorting criterium for this Dispatch
  Standard_EXPORT   Standard_CString SignName()  const;
  
  //! Returns as Label, "One File per Signature <name>"
  Standard_EXPORT   TCollection_AsciiString Label()  const;
  
  //! Returns True, maximum count is given as <nbent>
  Standard_EXPORT virtual   Standard_Boolean LimitedMax (const Standard_Integer nbent, Standard_Integer& max)  const;
  
  //! Computes the list of produced Packets. It defines Packets from
  //! the SignCounter, which sirts the input Entities per Signature
  //! (specific of the SignCounter).
  Standard_EXPORT   void Packets (const Interface_Graph& G, IFGraph_SubPartsIterator& packs)  const;




  DEFINE_STANDARD_RTTI(IFSelect_DispPerSignature)

protected:




private: 


  Handle(IFSelect_SignCounter) thesign;


};







#endif // _IFSelect_DispPerSignature_HeaderFile
