// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _IFSelect_SelectRoots_HeaderFile
#define _IFSelect_SelectRoots_HeaderFile

#include <Standard.hxx>
#include <Standard_DefineHandle.hxx>
#include <Handle_IFSelect_SelectRoots.hxx>

#include <IFSelect_SelectExtract.hxx>
#include <Standard_Boolean.hxx>
#include <Standard_Integer.hxx>
#include <Handle_Standard_Transient.hxx>
#include <Handle_Interface_InterfaceModel.hxx>
class Interface_EntityIterator;
class Interface_Graph;
class Standard_Transient;
class Interface_InterfaceModel;
class TCollection_AsciiString;


//! A SelectRoots sorts the Entities which are local roots of a
//! set of Entities (not shared by other Entities inside this set,
//! even if they are shared by other Entities outside it)
class IFSelect_SelectRoots : public IFSelect_SelectExtract
{

public:

  
  //! Creates a SelectRoots
  Standard_EXPORT IFSelect_SelectRoots();
  
  //! Returns the list of local roots. It is redefined for a purpose
  //! of effeciency : calling a Sort routine for each Entity would
  //! cost more ressource than to work in once using a Map
  //! RootResult takes in account the Direct status
  Standard_EXPORT virtual   Interface_EntityIterator RootResult (const Interface_Graph& G)  const;
  
  //! Returns always True, because RootResult has done work
  Standard_EXPORT   Standard_Boolean Sort (const Standard_Integer rank, const Handle(Standard_Transient)& ent, const Handle(Interface_InterfaceModel)& model)  const;
  
  //! Returns a text defining the criterium : "Local Root Entities"
  Standard_EXPORT   TCollection_AsciiString ExtractLabel()  const;




  DEFINE_STANDARD_RTTI(IFSelect_SelectRoots)

protected:

  
  //! Returns True, because RootResult assures uniqueness
  Standard_EXPORT virtual   Standard_Boolean HasUniqueResult()  const;



private: 




};







#endif // _IFSelect_SelectRoots_HeaderFile
