// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _IGESAppli_FiniteElement_HeaderFile
#define _IGESAppli_FiniteElement_HeaderFile

#include <Standard.hxx>
#include <Standard_DefineHandle.hxx>
#include <Handle_IGESAppli_FiniteElement.hxx>

#include <Standard_Integer.hxx>
#include <Handle_IGESAppli_HArray1OfNode.hxx>
#include <Handle_TCollection_HAsciiString.hxx>
#include <IGESData_IGESEntity.hxx>
#include <Handle_IGESAppli_Node.hxx>
class IGESAppli_HArray1OfNode;
class TCollection_HAsciiString;
class Standard_OutOfRange;
class IGESAppli_Node;


//! defines FiniteElement, Type <136> Form <0>
//! in package IGESAppli
//! Used to define a finite element with the help of an
//! element topology.
class IGESAppli_FiniteElement : public IGESData_IGESEntity
{

public:

  
  Standard_EXPORT IGESAppli_FiniteElement();
  
  //! This method is used to set the fields of the class
  //! FiniteElement
  //! - aType    : Indicates the topology type
  //! - allNodes : List of Nodes defining the element
  //! - aName    : Element type name
  Standard_EXPORT   void Init (const Standard_Integer aType, const Handle(IGESAppli_HArray1OfNode)& allNodes, const Handle(TCollection_HAsciiString)& aName) ;
  
  //! returns Topology type
  Standard_EXPORT   Standard_Integer Topology()  const;
  
  //! returns the number of nodes defining the element
  Standard_EXPORT   Standard_Integer NbNodes()  const;
  
  //! returns Node defining element entity
  //! raises exception if Index <= 0 or Index > NbNodes()
  Standard_EXPORT   Handle(IGESAppli_Node) Node (const Standard_Integer Index)  const;
  
  //! returns Element Type Name
  Standard_EXPORT   Handle(TCollection_HAsciiString) Name()  const;




  DEFINE_STANDARD_RTTI(IGESAppli_FiniteElement)

protected:




private: 


  Standard_Integer theTopology;
  Handle(IGESAppli_HArray1OfNode) theNodes;
  Handle(TCollection_HAsciiString) theName;


};







#endif // _IGESAppli_FiniteElement_HeaderFile
