// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _IGESAppli_NodalConstraint_HeaderFile
#define _IGESAppli_NodalConstraint_HeaderFile

#include <Standard.hxx>
#include <Standard_DefineHandle.hxx>
#include <Handle_IGESAppli_NodalConstraint.hxx>

#include <Standard_Integer.hxx>
#include <Handle_IGESAppli_Node.hxx>
#include <Handle_IGESDefs_HArray1OfTabularData.hxx>
#include <IGESData_IGESEntity.hxx>
#include <Handle_IGESDefs_TabularData.hxx>
class IGESAppli_Node;
class IGESDefs_HArray1OfTabularData;
class Standard_OutOfRange;
class IGESDefs_TabularData;


//! defines NodalConstraint, Type <418> Form <0>
//! in package IGESAppli
//! Relates loads and/or constraints to specific nodes in
//! the Finite Element Model by creating a relation between
//! Node entities and Tabular Data Property that contains
//! the load or constraint data
class IGESAppli_NodalConstraint : public IGESData_IGESEntity
{

public:

  
  Standard_EXPORT IGESAppli_NodalConstraint();
  
  //! This method is used to set the fields of the class
  //! NodalConstraint
  //! - aType      : Loads / Constraints
  //! - aNode      : the Node
  //! - allTabData : Tabular Data Property carrying the load
  //! or constraint vector
  Standard_EXPORT   void Init (const Standard_Integer aType, const Handle(IGESAppli_Node)& aNode, const Handle(IGESDefs_HArray1OfTabularData)& allTabData) ;
  
  //! returns total number of cases
  Standard_EXPORT   Standard_Integer NbCases()  const;
  
  //! returns whether Loads (1) or Constraints (2)
  Standard_EXPORT   Standard_Integer Type()  const;
  
  //! returns the Node
  Standard_EXPORT   Handle(IGESAppli_Node) NodeEntity()  const;
  
  //! returns Tabular Data Property carrying load or constraint vector
  //! raises exception if Index <= 0 or Index > NbCases
  Standard_EXPORT   Handle(IGESDefs_TabularData) TabularData (const Standard_Integer Index)  const;




  DEFINE_STANDARD_RTTI(IGESAppli_NodalConstraint)

protected:




private: 


  Standard_Integer theType;
  Handle(IGESAppli_Node) theNode;
  Handle(IGESDefs_HArray1OfTabularData) theTabularDataProps;


};







#endif // _IGESAppli_NodalConstraint_HeaderFile
