// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _IGESAppli_Node_HeaderFile
#define _IGESAppli_Node_HeaderFile

#include <Standard.hxx>
#include <Standard_DefineHandle.hxx>
#include <Handle_IGESAppli_Node.hxx>

#include <gp_XYZ.hxx>
#include <Handle_IGESGeom_TransformationMatrix.hxx>
#include <IGESData_IGESEntity.hxx>
#include <Handle_IGESData_TransfEntity.hxx>
#include <Standard_Integer.hxx>
class IGESGeom_TransformationMatrix;
class gp_XYZ;
class gp_Pnt;
class IGESData_TransfEntity;


//! defines Node, Type <134> Form <0>
//! in package IGESAppli
//! Geometric point used in the definition of a finite element.
class IGESAppli_Node : public IGESData_IGESEntity
{

public:

  
  Standard_EXPORT IGESAppli_Node();
  
  //! This method is used to set the fields of the class Node
  //! - aCoord       : Nodal Coordinates
  //! - aCoordSystem : the Nodal Displacement Coordinate
  //! System Entity (default 0 is Global
  //! Cartesian Coordinate system)
  Standard_EXPORT   void Init (const gp_XYZ& aCoord, const Handle(IGESGeom_TransformationMatrix)& aCoordSystem) ;
  
  //! returns the nodal coordinates
  Standard_EXPORT   gp_Pnt Coord()  const;
  
  //! returns TransfEntity if a Nodal Displacement Coordinate
  //! System Entity is defined
  //! else (for Global Cartesien) returns Null Handle
  Standard_EXPORT   Handle(IGESData_TransfEntity) System()  const;
  
  //! Computes & returns the Type of Coordinate System :
  //! 0 GlobalCartesian, 1 Cartesian, 2 Cylindrical, 3 Spherical
  Standard_EXPORT   Standard_Integer SystemType()  const;
  
  //! returns the Nodal coordinates after transformation
  Standard_EXPORT   gp_Pnt TransformedNodalCoord()  const;




  DEFINE_STANDARD_RTTI(IGESAppli_Node)

protected:




private: 


  gp_XYZ theCoord;
  Handle(IGESGeom_TransformationMatrix) theSystem;


};







#endif // _IGESAppli_Node_HeaderFile
