// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _IGESAppli_PWBDrilledHole_HeaderFile
#define _IGESAppli_PWBDrilledHole_HeaderFile

#include <Standard.hxx>
#include <Standard_DefineHandle.hxx>
#include <Handle_IGESAppli_PWBDrilledHole.hxx>

#include <Standard_Integer.hxx>
#include <Standard_Real.hxx>
#include <IGESData_IGESEntity.hxx>


//! defines PWBDrilledHole, Type <406> Form <26>
//! in package IGESAppli
//! Used to identify an entity that locates a drilled hole
//! and to specify the characteristics of the drilled hole
class IGESAppli_PWBDrilledHole : public IGESData_IGESEntity
{

public:

  
  Standard_EXPORT IGESAppli_PWBDrilledHole();
  
  //! This method is used to set the fields of the class
  //! PWBDrilledHole
  //! - nbPropVal  : number of property values, always = 3
  //! - aDrillDia  : Drill diameter size
  //! - aFinishDia : Finish diameter size
  //! - aCode      : Function code for drilled hole
  Standard_EXPORT   void Init (const Standard_Integer nbPropVal, const Standard_Real aDrillDia, const Standard_Real aFinishDia, const Standard_Integer aCode) ;
  
  //! returns number of property values, always = 3
  Standard_EXPORT   Standard_Integer NbPropertyValues()  const;
  
  //! returns Drill diameter size
  Standard_EXPORT   Standard_Real DrillDiameterSize()  const;
  
  //! returns Finish diameter size
  Standard_EXPORT   Standard_Real FinishDiameterSize()  const;
  
  //! returns Function code for drilled hole
  //! is 0, 1, 2, 3, 4, 5 or 5001-9999
  Standard_EXPORT   Standard_Integer FunctionCode()  const;




  DEFINE_STANDARD_RTTI(IGESAppli_PWBDrilledHole)

protected:




private: 


  Standard_Integer theNbPropertyValues;
  Standard_Real theDrillDiameter;
  Standard_Real theFinishDiameter;
  Standard_Integer theFunctionCode;


};







#endif // _IGESAppli_PWBDrilledHole_HeaderFile
