// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _IGESGeom_TabulatedCylinder_HeaderFile
#define _IGESGeom_TabulatedCylinder_HeaderFile

#include <Standard.hxx>
#include <Standard_DefineHandle.hxx>
#include <Handle_IGESGeom_TabulatedCylinder.hxx>

#include <Handle_IGESData_IGESEntity.hxx>
#include <gp_XYZ.hxx>
#include <IGESData_IGESEntity.hxx>
class IGESData_IGESEntity;
class gp_XYZ;
class gp_Pnt;


//! defines IGESTabulatedCylinder, Type <122> Form <0>
//! in package IGESGeom
//! A tabulated cylinder is a surface formed by moving a line
//! segment called generatrix parallel to itself along a curve
//! called directrix. The curve may be a line, circular arc,
//! conic arc, parametric spline curve, rational B-spline
//! curve or composite curve.
class IGESGeom_TabulatedCylinder : public IGESData_IGESEntity
{

public:

  
  Standard_EXPORT IGESGeom_TabulatedCylinder();
  
  //! This method is used to set the fields of the class
  //! TabulatedCylinder
  //! - aDirectrix : Directrix Curve of the tabulated cylinder
  //! - anEnd      : Coordinates of the terminate point of the
  //! generatrix
  //! The start point of the directrix is identical to the start
  //! point of the generatrix
  Standard_EXPORT   void Init (const Handle(IGESData_IGESEntity)& aDirectrix, const gp_XYZ& anEnd) ;
  
  //! returns the directrix curve of the tabulated cylinder
  Standard_EXPORT   Handle(IGESData_IGESEntity) Directrix()  const;
  
  //! returns end point of generatrix of the tabulated cylinder
  Standard_EXPORT   gp_Pnt EndPoint()  const;
  
  //! returns end point of generatrix of the tabulated cylinder
  //! after applying Transf. Matrix
  Standard_EXPORT   gp_Pnt TransformedEndPoint()  const;




  DEFINE_STANDARD_RTTI(IGESGeom_TabulatedCylinder)

protected:




private: 


  Handle(IGESData_IGESEntity) theDirectrix;
  gp_XYZ theEnd;


};







#endif // _IGESGeom_TabulatedCylinder_HeaderFile
