// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _IGESGraph_LineFontDefTemplate_HeaderFile
#define _IGESGraph_LineFontDefTemplate_HeaderFile

#include <Standard.hxx>
#include <Standard_DefineHandle.hxx>
#include <Handle_IGESGraph_LineFontDefTemplate.hxx>

#include <Standard_Integer.hxx>
#include <Handle_IGESBasic_SubfigureDef.hxx>
#include <Standard_Real.hxx>
#include <IGESData_LineFontEntity.hxx>
class IGESBasic_SubfigureDef;


//! defines IGESLineFontDefTemplate, Type <304> Form <1>
//! in package IGESGraph
//!
//! Line Font can be defined as a repetition od Template figure
//! that is displayed at regularly spaced locations along a
//! planer anchoring curve. The anchoring curve itself has
//! no visual purpose.
class IGESGraph_LineFontDefTemplate : public IGESData_LineFontEntity
{

public:

  
  Standard_EXPORT IGESGraph_LineFontDefTemplate();
  
  //! This method is used to set the fields of the class
  //! LineFontDefTemplate
  //! - anOrientation : Orientation of Template figure on
  //! anchoring curve
  //! - aTemplate     : SubfigureDef entity used as Template figure
  //! - aDistance     : Distance between the neighbouring Template
  //! figures
  //! - aScale        : Scale factor applied to the Template figure
  Standard_EXPORT   void Init (const Standard_Integer anOrientation, const Handle(IGESBasic_SubfigureDef)& aTemplate, const Standard_Real aDistance, const Standard_Real aScale) ;
  
  //! if return value = 0, Each Template display is oriented by aligning
  //! the axis of the SubfigureDef with the axis of
  //! the definition space of the anchoring curve.
  //! = 1, Each Template display is oriented by aligning
  //! X-axis of the SubfigureDef with the tangent
  //! vector of the anchoring curve at the point of
  //! incidence of the curve and the origin of
  //! subfigure.
  //! Similarly Z-axis is aligned.
  Standard_EXPORT   Standard_Integer Orientation()  const;
  
  //! returns SubfigureDef as the Entity used as Template figure.
  Standard_EXPORT   Handle(IGESBasic_SubfigureDef) TemplateEntity()  const;
  
  //! returns the Distance between any two Template figures on the
  //! anchoring curve.
  Standard_EXPORT   Standard_Real Distance()  const;
  
  //! returns the Scaling factor applied to SubfigureDef to form
  //! Template figure.
  Standard_EXPORT   Standard_Real Scale()  const;




  DEFINE_STANDARD_RTTI(IGESGraph_LineFontDefTemplate)

protected:




private: 


  Standard_Integer theOrientation;
  Handle(IGESBasic_SubfigureDef) theTemplateEntity;
  Standard_Real theDistance;
  Standard_Real theScale;


};







#endif // _IGESGraph_LineFontDefTemplate_HeaderFile
