// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _IGESSelect_AutoCorrect_HeaderFile
#define _IGESSelect_AutoCorrect_HeaderFile

#include <Standard.hxx>
#include <Standard_DefineHandle.hxx>
#include <Handle_IGESSelect_AutoCorrect.hxx>

#include <IGESSelect_ModelModifier.hxx>
#include <Handle_IGESData_IGESModel.hxx>
class IFSelect_ContextModif;
class IGESData_IGESModel;
class Interface_CopyTool;
class TCollection_AsciiString;


//! Does the absolutely effective corrections on IGES Entity.
//! That is to say : regarding the norm in details, some values
//! have mandatory values, or set of values with constraints.
//! When such values/constraints are univoque, they can be forced.
//! Also nullifies items of Directory Part, Associativities, and
//! Properties, which are not (or not longer) in <target> Model.
//!
//! Works by calling a BasicEditor from IGESData
//! Works with the specific IGES Services : DirChecker which
//! allows to correct data in "Directory Part" of Entities (such
//! as required values for status, or references to be null), and
//! the specific IGES service OwnCorrect, which is specialised for
//! each type of entity.
//!
//! Remark : this does not comprise the computation of use flag or
//! subordinate status according references, which is made by
//! the ModelModifier class ComputeStatus.
//!
//! The Input Selection, when present, designates the entities to
//! be corrected. If it is not present, all the entities of the
//! model are corrected.
class IGESSelect_AutoCorrect : public IGESSelect_ModelModifier
{

public:

  
  //! Creates an AutoCorrect.
  Standard_EXPORT IGESSelect_AutoCorrect();
  
  //! Specific action : corrects entities when it is absolutely
  //! obvious, i.e. non equivoque (by DirChecker and specific
  //! service OwnCorrect) : works with a protocol.
  Standard_EXPORT   void Performing (IFSelect_ContextModif& ctx, const Handle(IGESData_IGESModel)& target, Interface_CopyTool& TC)  const;
  
  //! Returns a text which is
  //! "Auto-correction of IGES Entities"
  Standard_EXPORT   TCollection_AsciiString Label()  const;




  DEFINE_STANDARD_RTTI(IGESSelect_AutoCorrect)

protected:




private: 




};







#endif // _IGESSelect_AutoCorrect_HeaderFile
