// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _IGESSelect_ComputeStatus_HeaderFile
#define _IGESSelect_ComputeStatus_HeaderFile

#include <Standard.hxx>
#include <Standard_DefineHandle.hxx>
#include <Handle_IGESSelect_ComputeStatus.hxx>

#include <IGESSelect_ModelModifier.hxx>
#include <Handle_IGESData_IGESModel.hxx>
class IFSelect_ContextModif;
class IGESData_IGESModel;
class Interface_CopyTool;
class TCollection_AsciiString;


//! Computes Status of IGES Entities for a whole IGESModel.
//! This concerns SubordinateStatus and UseFlag, which must have
//! some definite values according the way they are referenced.
//! (see definitions of Logical use, Physical use, etc...)
//!
//! Works by calling a BasicEditor from IGESData. Works on the
//! whole produced (target) model, because computation is global.
class IGESSelect_ComputeStatus : public IGESSelect_ModelModifier
{

public:

  
  //! Creates an ComputeStatus, which uses the system Date
  Standard_EXPORT IGESSelect_ComputeStatus();
  
  //! Specific action : it first evaluates the required values for
  //! Subordinate Status and Use Flag (in Directory Part of each
  //! IGES Entity). Then it corrects them, for the whole target.
  //! Works with a Protocol. Implementation uses BasicEditor
  Standard_EXPORT   void Performing (IFSelect_ContextModif& ctx, const Handle(IGESData_IGESModel)& target, Interface_CopyTool& TC)  const;
  
  //! Returns a text which is
  //! "Compute Subordinate Status and Use Flag"
  Standard_EXPORT   TCollection_AsciiString Label()  const;




  DEFINE_STANDARD_RTTI(IGESSelect_ComputeStatus)

protected:




private: 




};







#endif // _IGESSelect_ComputeStatus_HeaderFile
