// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _IGESSolid_BooleanTree_HeaderFile
#define _IGESSolid_BooleanTree_HeaderFile

#include <Standard.hxx>
#include <Standard_DefineHandle.hxx>
#include <Handle_IGESSolid_BooleanTree.hxx>

#include <Handle_IGESData_HArray1OfIGESEntity.hxx>
#include <Handle_TColStd_HArray1OfInteger.hxx>
#include <IGESData_IGESEntity.hxx>
#include <Standard_Integer.hxx>
#include <Standard_Boolean.hxx>
#include <Handle_IGESData_IGESEntity.hxx>
class IGESData_HArray1OfIGESEntity;
class TColStd_HArray1OfInteger;
class Standard_OutOfRange;
class IGESData_IGESEntity;


//! defines BooleanTree, Type <180> Form Number <0>
//! in package IGESSolid
//! The Boolean tree describes a binary tree structure
//! composed of regularized Boolean operations and operands,
//! in post-order notation.
class IGESSolid_BooleanTree : public IGESData_IGESEntity
{

public:

  
  Standard_EXPORT IGESSolid_BooleanTree();
  
  //! This method is used to set the fields of the class
  //! BooleanTree
  //! - operands   : Array containing pointer to DE of operands
  //! - operations : Array containing integer type for operations
  Standard_EXPORT   void Init (const Handle(IGESData_HArray1OfIGESEntity)& operands, const Handle(TColStd_HArray1OfInteger)& operations) ;
  
  //! returns the length of the post-order list
  Standard_EXPORT   Standard_Integer Length()  const;
  
  //! returns True if Index'th value in the post-order list is an Operand;
  //! else returns False if it is an Integer Operations
  //! raises exception if Index < 1 or Index > Length()
  Standard_EXPORT   Standard_Boolean IsOperand (const Standard_Integer Index)  const;
  
  //! returns the Index'th value in the post-order list only if it is
  //! an operand else returns NULL
  //! raises exception if Index < 1 or Index > Length()
  Standard_EXPORT   Handle(IGESData_IGESEntity) Operand (const Standard_Integer Index)  const;
  
  //! returns the Index'th value in the post-order list only if it is
  //! an operation else returns 0
  //! raises exception if Index < 1 or Index > Length()
  Standard_EXPORT   Standard_Integer Operation (const Standard_Integer Index)  const;




  DEFINE_STANDARD_RTTI(IGESSolid_BooleanTree)

protected:




private: 


  Handle(IGESData_HArray1OfIGESEntity) theOperands;
  Handle(TColStd_HArray1OfInteger) theOperations;


};







#endif // _IGESSolid_BooleanTree_HeaderFile
