// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _IGESSolid_PlaneSurface_HeaderFile
#define _IGESSolid_PlaneSurface_HeaderFile

#include <Standard.hxx>
#include <Standard_DefineHandle.hxx>
#include <Handle_IGESSolid_PlaneSurface.hxx>

#include <Handle_IGESGeom_Point.hxx>
#include <Handle_IGESGeom_Direction.hxx>
#include <IGESData_IGESEntity.hxx>
#include <Standard_Boolean.hxx>
class IGESGeom_Point;
class IGESGeom_Direction;


//! defines PlaneSurface, Type <190> Form Number <0,1>
//! in package IGESSolid
//! A plane surface entity is defined by a point on the
//! surface and a normal to it.
class IGESSolid_PlaneSurface : public IGESData_IGESEntity
{

public:

  
  Standard_EXPORT IGESSolid_PlaneSurface();
  
  //! This method is used to set the fields of the class
  //! PlaneSurface
  //! - aLocation : the point on the surface
  //! - aNormal   : the surface normal direction
  //! - refdir    : the reference direction (default NULL) for
  //! unparameterised curves
  Standard_EXPORT   void Init (const Handle(IGESGeom_Point)& aLocation, const Handle(IGESGeom_Direction)& aNormal, const Handle(IGESGeom_Direction)& refdir) ;
  
  //! returns the point on the surface
  Standard_EXPORT   Handle(IGESGeom_Point) LocationPoint()  const;
  
  //! returns the normal to the surface
  Standard_EXPORT   Handle(IGESGeom_Direction) Normal()  const;
  
  //! returns the reference direction (for parameterised curve)
  //! returns NULL for unparameterised curve
  Standard_EXPORT   Handle(IGESGeom_Direction) ReferenceDir()  const;
  
  //! returns True if parameterised, else False
  Standard_EXPORT   Standard_Boolean IsParametrised()  const;




  DEFINE_STANDARD_RTTI(IGESSolid_PlaneSurface)

protected:




private: 


  Handle(IGESGeom_Point) theLocationPoint;
  Handle(IGESGeom_Direction) theNormal;
  Handle(IGESGeom_Direction) theRefDir;


};







#endif // _IGESSolid_PlaneSurface_HeaderFile
