// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _IGESSolid_ToroidalSurface_HeaderFile
#define _IGESSolid_ToroidalSurface_HeaderFile

#include <Standard.hxx>
#include <Standard_DefineHandle.hxx>
#include <Handle_IGESSolid_ToroidalSurface.hxx>

#include <Handle_IGESGeom_Point.hxx>
#include <Handle_IGESGeom_Direction.hxx>
#include <Standard_Real.hxx>
#include <IGESData_IGESEntity.hxx>
#include <Standard_Boolean.hxx>
class IGESGeom_Point;
class IGESGeom_Direction;
class gp_Pnt;


//! defines ToroidalSurface, Type <198> Form Number <0,1>
//! in package IGESSolid
//! This entity is defined by the center point, the axis
//! direction and the major and minor radii. In case of
//! parametrised surface a reference direction is provided.
class IGESSolid_ToroidalSurface : public IGESData_IGESEntity
{

public:

  
  Standard_EXPORT IGESSolid_ToroidalSurface();
  
  //! This method is used to set the fields of the class
  //! ToroidalSurface
  //! - aCenter   : the center point coordinates
  //! - anAxis    : the direction of the axis
  //! - majRadius : the major radius
  //! - minRadius : the minor radius
  //! - Refdir    : the reference direction (parametrised)
  //! default Null for unparametrised surface
  Standard_EXPORT   void Init (const Handle(IGESGeom_Point)& aCenter, const Handle(IGESGeom_Direction)& anAxis, const Standard_Real majRadius, const Standard_Real minRadius, const Handle(IGESGeom_Direction)& Refdir) ;
  
  //! returns the center point coordinates of the surface
  Standard_EXPORT   Handle(IGESGeom_Point) Center()  const;
  
  //! returns the center point coordinates of the surface
  //! after applying TransformationMatrix
  Standard_EXPORT   gp_Pnt TransformedCenter()  const;
  
  //! returns the direction of the axis
  Standard_EXPORT   Handle(IGESGeom_Direction) Axis()  const;
  
  //! returns the major radius of the surface
  Standard_EXPORT   Standard_Real MajorRadius()  const;
  
  //! returns the minor radius of the surface
  Standard_EXPORT   Standard_Real MinorRadius()  const;
  
  //! returns the reference direction (parametrised surface)
  //! Null is returned if the surface is not parametrised
  Standard_EXPORT   Handle(IGESGeom_Direction) ReferenceDir()  const;
  
  //! Returns True if the surface is parametrised, else False
  Standard_EXPORT   Standard_Boolean IsParametrised()  const;




  DEFINE_STANDARD_RTTI(IGESSolid_ToroidalSurface)

protected:




private: 


  Handle(IGESGeom_Point) theCenter;
  Handle(IGESGeom_Direction) theAxis;
  Standard_Real theMajorRadius;
  Standard_Real theMinorRadius;
  Handle(IGESGeom_Direction) theRefDir;


};







#endif // _IGESSolid_ToroidalSurface_HeaderFile
