// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _IGESToBRep_BRepEntity_HeaderFile
#define _IGESToBRep_BRepEntity_HeaderFile

#include <Standard.hxx>
#include <Standard_DefineAlloc.hxx>
#include <Standard_Macro.hxx>

#include <IGESToBRep_CurveAndSurface.hxx>
#include <Standard_Real.hxx>
#include <Standard_Boolean.hxx>
#include <Handle_IGESData_IGESEntity.hxx>
#include <Handle_IGESSolid_VertexList.hxx>
#include <Standard_Integer.hxx>
#include <Handle_IGESSolid_EdgeList.hxx>
#include <Handle_IGESSolid_Loop.hxx>
#include <Handle_IGESSolid_Face.hxx>
#include <Handle_IGESSolid_Shell.hxx>
#include <Handle_IGESSolid_ManifoldSolid.hxx>
class IGESToBRep_CurveAndSurface;
class TopoDS_Shape;
class IGESData_IGESEntity;
class TopoDS_Vertex;
class IGESSolid_VertexList;
class IGESSolid_EdgeList;
class IGESSolid_Loop;
class TopoDS_Face;
class gp_Trsf2d;
class IGESSolid_Face;
class IGESSolid_Shell;
class IGESSolid_ManifoldSolid;


//! Provides methods to transfer BRep entities
//! ( VertexList 502, EdgeList 504, Loop 508,
//! Face 510, Shell 514, ManifoldSolid 186)
//! from IGES to CASCADE.
class IGESToBRep_BRepEntity  : public IGESToBRep_CurveAndSurface
{
public:

  DEFINE_STANDARD_ALLOC

  
  //! Creates  a tool BRepEntity  ready  to  run, with
  //! epsilons  set  to  1.E-04,  TheModeTopo  to  True,  the
  //! optimization of  the continuity to False.
  Standard_EXPORT IGESToBRep_BRepEntity();
  
  //! Creates a tool BRepEntity ready to run and sets its
  //! fields as CS's.
  Standard_EXPORT IGESToBRep_BRepEntity(const IGESToBRep_CurveAndSurface& CS);
  
  //! Creates a tool BRepEntity ready to run.
  Standard_EXPORT IGESToBRep_BRepEntity(const Standard_Real eps, const Standard_Real epsGeom, const Standard_Real epsCoeff, const Standard_Boolean mode, const Standard_Boolean modeapprox, const Standard_Boolean optimized);
  
  //! Transfer the BRepEntity" : Face, Shell or ManifoldSolid.
  Standard_EXPORT   TopoDS_Shape TransferBRepEntity (const Handle(IGESData_IGESEntity)& start) ;
  
  //! Transfer the entity number "index" of the VertexList "start"
  Standard_EXPORT   TopoDS_Vertex TransferVertex (const Handle(IGESSolid_VertexList)& start, const Standard_Integer index) ;
  
  //! Transfer the entity number "index" of the EdgeList "start".
  Standard_EXPORT   TopoDS_Shape TransferEdge (const Handle(IGESSolid_EdgeList)& start, const Standard_Integer index) ;
  
  //! Transfer the Loop Entity
  Standard_EXPORT   TopoDS_Shape TransferLoop (const Handle(IGESSolid_Loop)& start, const TopoDS_Face& Face, const gp_Trsf2d& trans, const Standard_Real uFact) ;
  
  //! Transfer the Face Entity
  Standard_EXPORT   TopoDS_Shape TransferFace (const Handle(IGESSolid_Face)& start) ;
  
  //! Transfer the Shell Entity
  Standard_EXPORT   TopoDS_Shape TransferShell (const Handle(IGESSolid_Shell)& start) ;
  
  //! Transfer the ManifoldSolid Entity
  Standard_EXPORT   TopoDS_Shape TransferManifoldSolid (const Handle(IGESSolid_ManifoldSolid)& start) ;




protected:





private:





};







#endif // _IGESToBRep_BRepEntity_HeaderFile
