// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _IntSurf_InteriorPoint_HeaderFile
#define _IntSurf_InteriorPoint_HeaderFile

#include <Standard.hxx>
#include <Standard_DefineAlloc.hxx>
#include <Standard_Macro.hxx>

#include <gp_Pnt.hxx>
#include <Standard_Real.hxx>
#include <gp_Vec.hxx>
#include <gp_Vec2d.hxx>
class gp_Pnt;
class gp_Vec;
class gp_Vec2d;


//! Definition of a point solution of the
//! intersection between an implicit an a
//! parametrised surface. These points are
//! passing points on the intersection lines,
//! or starting points for the closed lines
//! on the parametrised surface.
class IntSurf_InteriorPoint 
{
public:

  DEFINE_STANDARD_ALLOC

  
  Standard_EXPORT IntSurf_InteriorPoint();
  
  Standard_EXPORT IntSurf_InteriorPoint(const gp_Pnt& P, const Standard_Real U, const Standard_Real V, const gp_Vec& Direc, const gp_Vec2d& Direc2d);
  
  Standard_EXPORT   void SetValue (const gp_Pnt& P, const Standard_Real U, const Standard_Real V, const gp_Vec& Direc, const gp_Vec2d& Direc2d) ;
  
  //! Returns the 3d coordinates of the interior point.
     const  gp_Pnt& Value()  const;
  
  //! Returns the parameters of the interior point on the
  //! parametric surface.
      void Parameters (Standard_Real& U, Standard_Real& V)  const;
  
  //! Returns the first parameter of the interior point on the
  //! parametric surface.
      Standard_Real UParameter()  const;
  
  //! Returns the second parameter of the interior point on the
  //! parametric surface.
      Standard_Real VParameter()  const;
  
  //! Returns the tangent at the intersection in 3d space
  //! associated to the interior point.
     const  gp_Vec& Direction()  const;
  
  //! Returns the tangent at the intersection in the parametric
  //! space of the parametric surface.
     const  gp_Vec2d& Direction2d()  const;




protected:





private:



  gp_Pnt point;
  Standard_Real paramu;
  Standard_Real paramv;
  gp_Vec direc;
  gp_Vec2d direc2d;


};


#include <IntSurf_InteriorPoint.lxx>





#endif // _IntSurf_InteriorPoint_HeaderFile
