// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _ProjLib_Sphere_HeaderFile
#define _ProjLib_Sphere_HeaderFile

#include <Standard.hxx>
#include <Standard_DefineAlloc.hxx>
#include <Standard_Macro.hxx>

#include <gp_Sphere.hxx>
#include <ProjLib_Projector.hxx>
#include <Standard_Real.hxx>
class Standard_NoSuchObject;
class gp_Sphere;
class gp_Circ;
class gp_Lin;
class gp_Elips;
class gp_Parab;
class gp_Hypr;


//! Projects elementary curves on a sphere.
class ProjLib_Sphere  : public ProjLib_Projector
{
public:

  DEFINE_STANDARD_ALLOC

  
  //! Undefined projection.
  Standard_EXPORT ProjLib_Sphere();
  
  //! Projection on the sphere <Sp>.
  Standard_EXPORT ProjLib_Sphere(const gp_Sphere& Sp);
  
  //! Projection of the circle <C> on the sphere <Sp>.
  Standard_EXPORT ProjLib_Sphere(const gp_Sphere& Sp, const gp_Circ& C);
  
  Standard_EXPORT   void Init (const gp_Sphere& Sp) ;
  
  Standard_EXPORT virtual   void Project (const gp_Lin& L) ;
  
  Standard_EXPORT virtual   void Project (const gp_Circ& C) ;
  
  Standard_EXPORT virtual   void Project (const gp_Elips& E) ;
  
  Standard_EXPORT virtual   void Project (const gp_Parab& P) ;
  
  Standard_EXPORT virtual   void Project (const gp_Hypr& H) ;
  
  //! Set the point of parameter U on C in the natural
  //! restrictions of the sphere.
  Standard_EXPORT   void SetInBounds (const Standard_Real U) ;




protected:





private:



  gp_Sphere mySphere;


};







#endif // _ProjLib_Sphere_HeaderFile
