// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _STEPConstruct_Assembly_HeaderFile
#define _STEPConstruct_Assembly_HeaderFile

#include <Standard.hxx>
#include <Standard_DefineAlloc.hxx>
#include <Standard_Macro.hxx>

#include <Handle_StepShape_ShapeDefinitionRepresentation.hxx>
#include <Handle_StepShape_ShapeRepresentation.hxx>
#include <Handle_Standard_Transient.hxx>
#include <Handle_StepGeom_Axis2Placement3d.hxx>
#include <Handle_StepRepr_NextAssemblyUsageOccurrence.hxx>
#include <Standard_Boolean.hxx>
#include <Handle_Interface_InterfaceModel.hxx>
#include <Handle_StepShape_ContextDependentShapeRepresentation.hxx>
class StepShape_ShapeDefinitionRepresentation;
class StepShape_ShapeRepresentation;
class Standard_Transient;
class StepGeom_Axis2Placement3d;
class StepRepr_NextAssemblyUsageOccurrence;
class Interface_InterfaceModel;
class StepShape_ContextDependentShapeRepresentation;


//! This operator creates and checks an item of an assembly, from its
//! basic data : a ShapeRepresentation, a Location ...
//!
//! Three ways of coding such item from a ShapeRepresentation :
//! - do nothing : i.e. informations for assembly are ignored
//! - create a MappedItem
//! - create a RepresentationRelationship (WithTransformation)
class STEPConstruct_Assembly 
{
public:

  DEFINE_STANDARD_ALLOC

  
  Standard_EXPORT STEPConstruct_Assembly();
  
  //! Initialises with starting values
  //! Ax0 : origin axis (typically, standard XYZ)
  //! Loc : location to which place the item
  //! Makes a MappedItem
  //! Resulting Value is returned by ItemValue
  Standard_EXPORT   void Init (const Handle(StepShape_ShapeDefinitionRepresentation)& aSR, const Handle(StepShape_ShapeDefinitionRepresentation)& SDR0, const Handle(StepGeom_Axis2Placement3d)& Ax0, const Handle(StepGeom_Axis2Placement3d)& Loc) ;
  
  //! Make a (ShapeRepresentationRelationship,...WithTransformation)
  //! Resulting Value is returned by ItemValue
  Standard_EXPORT   void MakeRelationship() ;
  
  //! Returns the Value
  //! If no Make... has been called, returns the starting SR
  Standard_EXPORT   Handle(Standard_Transient) ItemValue()  const;
  
  //! Returns the location of the item, computed from starting aLoc
  Standard_EXPORT   Handle(StepGeom_Axis2Placement3d) ItemLocation()  const;
  
  //! Returns NAUO object describing the assembly link
  Standard_EXPORT   Handle(StepRepr_NextAssemblyUsageOccurrence) GetNAUO()  const;
  
  //! Checks whether SRR's definition of assembly and component contradicts
  //! with NAUO definition or not, according to model schema (AP214 or AP203)
  Standard_EXPORT static   Standard_Boolean CheckSRRReversesNAUO (const Handle(Interface_InterfaceModel)& Model, const Handle(StepShape_ContextDependentShapeRepresentation)& CDSR) ;




protected:





private:



  Handle(StepShape_ShapeDefinitionRepresentation) thesdr;
  Handle(StepShape_ShapeDefinitionRepresentation) thesdr0;
  Handle(StepShape_ShapeRepresentation) thesr;
  Handle(StepShape_ShapeRepresentation) thesr0;
  Handle(Standard_Transient) theval;
  Handle(StepGeom_Axis2Placement3d) theloc;
  Handle(StepGeom_Axis2Placement3d) theax0;


};







#endif // _STEPConstruct_Assembly_HeaderFile
