// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _STEPControl_Controller_HeaderFile
#define _STEPControl_Controller_HeaderFile

#include <Standard.hxx>
#include <Standard_DefineHandle.hxx>
#include <Handle_STEPControl_Controller.hxx>

#include <XSControl_Controller.hxx>
#include <Handle_Interface_InterfaceModel.hxx>
#include <Handle_Transfer_ActorOfTransientProcess.hxx>
#include <Handle_XSControl_WorkSession.hxx>
#include <IFSelect_ReturnStatus.hxx>
#include <Handle_Transfer_FinderProcess.hxx>
#include <Standard_Integer.hxx>
#include <Standard_Boolean.hxx>
class Interface_InterfaceModel;
class Transfer_ActorOfTransientProcess;
class XSControl_WorkSession;
class TopoDS_Shape;
class Transfer_FinderProcess;


//! defines basic controller for STEP processor
class STEPControl_Controller : public XSControl_Controller
{

public:

  
  //! Initializes the use of STEP Norm (the first time) and
  //! returns a Controller
  Standard_EXPORT STEPControl_Controller();
  
  //! Creates a new empty Model ready to receive data of the Norm.
  //! It is taken from STEP Template Model
  Standard_EXPORT   Handle(Interface_InterfaceModel) NewModel()  const;
  
  //! Returns a new Actor for Read attached to the pair (norm,appli)
  //! It is a PmsToTopoDSAct_Actor
  Standard_EXPORT   Handle(Transfer_ActorOfTransientProcess) ActorRead (const Handle(Interface_InterfaceModel)& model)  const;
  
  Standard_EXPORT virtual   void Customise (Handle(XSControl_WorkSession)& WS) ;
  
  //! Takes one Shape and transfers it to the InterfaceModel
  //! (already created by NewModel for instance)
  //! <modeshape> is to be interpreted by each kind of XstepAdaptor
  //! Returns a status : 0 OK  1 No result  2 Fail  -1 bad modeshape
  //! -2 bad model (requires a StepModel)
  //! modeshape : 1 Facetted BRep, 2 Shell, 3 Manifold Solid
  Standard_EXPORT virtual   IFSelect_ReturnStatus TransferWriteShape (const TopoDS_Shape& shape, const Handle(Transfer_FinderProcess)& FP, const Handle(Interface_InterfaceModel)& model, const Standard_Integer modetrans = 0)  const;
  
  //! Standard Initialisation. It creates a Controller for STEP
  //! and records it to various names, available to select it later
  //! Returns True when done, False if could not be done
  Standard_EXPORT static   Standard_Boolean Init() ;




  DEFINE_STANDARD_RTTI(STEPControl_Controller)

protected:




private: 




};







#endif // _STEPControl_Controller_HeaderFile
