// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _SelectMgr_TypeOfBVHUpdate_HeaderFile
#define _SelectMgr_TypeOfBVHUpdate_HeaderFile

#include <Standard_PrimitiveTypes.hxx>

//! Keeps track for BVH update state for each SelectMgr_Selection entity in a following way:
//! - Add        : 2nd level BVH does not contain any of the selection's sensitive entities and they must be
//! added;
//! - Remove     : all sensitive entities of the selection must be removed from 2nd level BVH;
//! - Renew      : 2nd level BVH already contains sensitives of the selection, but the its complete update
//! and removal is required. Therefore, sensitives of the selection with this type of update
//! must be removed from 2nd level BVH and added after recomputation.
//! - Invalidate : the 2nd level BVH needs to be rebuilt;
//! - None       : entities of the selection are up to date.
enum SelectMgr_TypeOfBVHUpdate
{
SelectMgr_TBU_Add,
SelectMgr_TBU_Remove,
SelectMgr_TBU_Renew,
SelectMgr_TBU_Invalidate,
SelectMgr_TBU_None
};

#endif // _SelectMgr_TypeOfBVHUpdate_HeaderFile
