// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _ShapeProcess_HeaderFile
#define _ShapeProcess_HeaderFile

#include <Standard.hxx>
#include <Standard_DefineAlloc.hxx>
#include <Standard_Macro.hxx>

#include <Standard_Boolean.hxx>
#include <Standard_CString.hxx>
#include <Handle_ShapeProcess_Operator.hxx>
#include <Handle_ShapeProcess_Context.hxx>
class ShapeProcess_Operator;
class ShapeProcess_Context;
class ShapeProcess_Context;
class ShapeProcess_ShapeContext;
class ShapeProcess_Operator;
class ShapeProcess_UOperator;
class ShapeProcess_OperLibrary;
class ShapeProcess_DictionaryOfOperator;
class ShapeProcess_IteratorOfDictionaryOfOperator;
class ShapeProcess_StackItemOfDictionaryOfOperator;


//! Shape Processing module
//! allows to define and apply general Shape Processing as a
//! customizable sequence of Shape Healing operators. The
//! customization is implemented via user-editable resource
//! file which defines sequence of operators to be executed
//! and their parameters.
class ShapeProcess 
{
public:

  DEFINE_STANDARD_ALLOC

  
  //! Registers operator to make it visible for Performer
  Standard_EXPORT static   Standard_Boolean RegisterOperator (const Standard_CString name, const Handle(ShapeProcess_Operator)& op) ;
  
  //! Finds operator by its name
  Standard_EXPORT static   Standard_Boolean FindOperator (const Standard_CString name, Handle(ShapeProcess_Operator)& op) ;
  
  //! Performs a specified sequence of operators on Context
  //! Resource file and other data should be already loaded
  //! to Context (including description of sequence seq)
  Standard_EXPORT static   Standard_Boolean Perform (const Handle(ShapeProcess_Context)& context, const Standard_CString seq) ;




protected:





private:




friend class ShapeProcess_Context;
friend class ShapeProcess_ShapeContext;
friend class ShapeProcess_Operator;
friend class ShapeProcess_UOperator;
friend class ShapeProcess_OperLibrary;
friend class ShapeProcess_DictionaryOfOperator;
friend class ShapeProcess_IteratorOfDictionaryOfOperator;
friend class ShapeProcess_StackItemOfDictionaryOfOperator;

};







#endif // _ShapeProcess_HeaderFile
