// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _ShapeUpgrade_ClosedFaceDivide_HeaderFile
#define _ShapeUpgrade_ClosedFaceDivide_HeaderFile

#include <Standard.hxx>
#include <Standard_DefineHandle.hxx>
#include <Handle_ShapeUpgrade_ClosedFaceDivide.hxx>

#include <Standard_Integer.hxx>
#include <ShapeUpgrade_FaceDivide.hxx>
#include <Standard_Boolean.hxx>
class TopoDS_Face;


//! Divides a Face with one or more seam edge to avoid closed faces.
//! Splitting is performed by U and V direction. The number of
//! resulting faces can be defined by user.
class ShapeUpgrade_ClosedFaceDivide : public ShapeUpgrade_FaceDivide
{

public:

  
  //! Creates empty  constructor.
  Standard_EXPORT ShapeUpgrade_ClosedFaceDivide();
  
  //! Initialize by a Face.
  Standard_EXPORT ShapeUpgrade_ClosedFaceDivide(const TopoDS_Face& F);
  
  //! Performs splitting of surface and computes the shell
  //! from source face.
  Standard_EXPORT virtual   Standard_Boolean SplitSurface() ;
  
  //! Sets the number of cutting lines by which closed face
  //! will be splitted. The resulting faces will be num+1.
  Standard_EXPORT   void SetNbSplitPoints (const Standard_Integer num) ;
  
  //! Returns the number of splitting points
  Standard_EXPORT   Standard_Integer GetNbSplitPoints()  const;




  DEFINE_STANDARD_RTTI(ShapeUpgrade_ClosedFaceDivide)

protected:




private: 


  Standard_Integer myNbSplit;


};







#endif // _ShapeUpgrade_ClosedFaceDivide_HeaderFile
