// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _ShapeUpgrade_ConvertCurve2dToBezier_HeaderFile
#define _ShapeUpgrade_ConvertCurve2dToBezier_HeaderFile

#include <Standard.hxx>
#include <Standard_DefineHandle.hxx>
#include <Handle_ShapeUpgrade_ConvertCurve2dToBezier.hxx>

#include <Handle_TColGeom2d_HSequenceOfCurve.hxx>
#include <Handle_TColStd_HSequenceOfReal.hxx>
#include <ShapeUpgrade_SplitCurve2d.hxx>
#include <Standard_Boolean.hxx>
class TColGeom2d_HSequenceOfCurve;
class TColStd_HSequenceOfReal;


//! converts/splits a 2d curve to a list of beziers
class ShapeUpgrade_ConvertCurve2dToBezier : public ShapeUpgrade_SplitCurve2d
{

public:

  
  //! Empty constructor.
  Standard_EXPORT ShapeUpgrade_ConvertCurve2dToBezier();
  
  //! Converts curve into a list of beziers, and stores the
  //! splitting parameters on original curve.
  Standard_EXPORT virtual   void Compute() ;
  
  //! Splits a list of beziers computed by Compute method according
  //! the split values and splitting parameters.
  Standard_EXPORT virtual   void Build (const Standard_Boolean Segment) ;
  
  //! Returns the list of splitted parameters in original curve
  //! parametrisation.
  Standard_EXPORT   Handle(TColStd_HSequenceOfReal) SplitParams()  const;




  DEFINE_STANDARD_RTTI(ShapeUpgrade_ConvertCurve2dToBezier)

protected:




private: 

  
  //! Returns the list of bezier curves correspondent to original
  //! curve.
  Standard_EXPORT   Handle(TColGeom2d_HSequenceOfCurve) Segments()  const;

  Handle(TColGeom2d_HSequenceOfCurve) mySegments;
  Handle(TColStd_HSequenceOfReal) mySplitParams;


};







#endif // _ShapeUpgrade_ConvertCurve2dToBezier_HeaderFile
