// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _ShapeUpgrade_SplitCurve2dContinuity_HeaderFile
#define _ShapeUpgrade_SplitCurve2dContinuity_HeaderFile

#include <Standard.hxx>
#include <Standard_DefineHandle.hxx>
#include <Handle_ShapeUpgrade_SplitCurve2dContinuity.hxx>

#include <GeomAbs_Shape.hxx>
#include <Standard_Integer.hxx>
#include <Standard_Real.hxx>
#include <ShapeUpgrade_SplitCurve2d.hxx>


//! Corrects/splits a 2d curve with a continuity criterion.
//! Tolerance is used to correct the curve at a knot that respects
//! geometrically the criterion, in order to reduce the
//! multiplicity of the knot.
class ShapeUpgrade_SplitCurve2dContinuity : public ShapeUpgrade_SplitCurve2d
{

public:

  
  //! Empty constructor.
  Standard_EXPORT ShapeUpgrade_SplitCurve2dContinuity();
  
  //! Sets criterion for splitting.
  Standard_EXPORT   void SetCriterion (const GeomAbs_Shape Criterion) ;
  
  //! Sets tolerance.
  Standard_EXPORT   void SetTolerance (const Standard_Real Tol) ;
  
  //! Calculates points for correction/splitting of the curve
  Standard_EXPORT virtual   void Compute() ;




  DEFINE_STANDARD_RTTI(ShapeUpgrade_SplitCurve2dContinuity)

protected:




private: 


  GeomAbs_Shape myCriterion;
  Standard_Integer myCont;
  Standard_Real myTolerance;


};







#endif // _ShapeUpgrade_SplitCurve2dContinuity_HeaderFile
