// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _ShapeUpgrade_SplitCurve3dContinuity_HeaderFile
#define _ShapeUpgrade_SplitCurve3dContinuity_HeaderFile

#include <Standard.hxx>
#include <Standard_DefineHandle.hxx>
#include <Handle_ShapeUpgrade_SplitCurve3dContinuity.hxx>

#include <GeomAbs_Shape.hxx>
#include <Standard_Real.hxx>
#include <Standard_Integer.hxx>
#include <ShapeUpgrade_SplitCurve3d.hxx>
#include <Handle_Geom_Curve.hxx>
class Geom_Curve;


//! Corrects/splits a 2d curve with a continuity criterion.
//! Tolerance is used to correct the curve at a knot that respects
//! geometrically the criterion, in order to reduce the
//! multiplicity of the knot.
class ShapeUpgrade_SplitCurve3dContinuity : public ShapeUpgrade_SplitCurve3d
{

public:

  
  //! Empty constructor.
  Standard_EXPORT ShapeUpgrade_SplitCurve3dContinuity();
  
  //! Sets criterion for splitting.
  Standard_EXPORT   void SetCriterion (const GeomAbs_Shape Criterion) ;
  
  //! Sets tolerance.
  Standard_EXPORT   void SetTolerance (const Standard_Real Tol) ;
  
  //! Calculates points for correction/splitting of the curve
  Standard_EXPORT virtual   void Compute() ;
  
  Standard_EXPORT  const  Handle(Geom_Curve)& GetCurve()  const;




  DEFINE_STANDARD_RTTI(ShapeUpgrade_SplitCurve3dContinuity)

protected:




private: 


  GeomAbs_Shape myCriterion;
  Standard_Real myTolerance;
  Standard_Integer myCont;


};







#endif // _ShapeUpgrade_SplitCurve3dContinuity_HeaderFile
