// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _StdSelect_FaceFilter_HeaderFile
#define _StdSelect_FaceFilter_HeaderFile

#include <Standard.hxx>
#include <Standard_DefineHandle.hxx>
#include <Handle_StdSelect_FaceFilter.hxx>

#include <StdSelect_TypeOfFace.hxx>
#include <SelectMgr_Filter.hxx>
#include <Standard_Boolean.hxx>
#include <Handle_SelectMgr_EntityOwner.hxx>
#include <TopAbs_ShapeEnum.hxx>
class SelectMgr_EntityOwner;


//! A framework to define a filter to select a specific type of face.
//! The types available include:
//! -   any face
//! -   a planar face
//! -   a cylindrical face
//! -   a spherical face
//! -   a toroidal face
//! -   a revol face.
class StdSelect_FaceFilter : public SelectMgr_Filter
{

public:

  
  //! Constructs a face filter object defined by the type of face aTypeOfFace.
  Standard_EXPORT StdSelect_FaceFilter(const StdSelect_TypeOfFace aTypeOfFace);
  
  //! Sets the type of face aNewType. aNewType is to be highlighted in selection.
  Standard_EXPORT   void SetType (const StdSelect_TypeOfFace aNewType) ;
  
  //! Returns the type of face to be highlighted in selection.
  Standard_EXPORT   StdSelect_TypeOfFace Type()  const;
  
  Standard_EXPORT virtual   Standard_Boolean IsOk (const Handle(SelectMgr_EntityOwner)& anobj)  const;
  
  Standard_EXPORT virtual   Standard_Boolean ActsOn (const TopAbs_ShapeEnum aStandardMode)  const;




  DEFINE_STANDARD_RTTI(StdSelect_FaceFilter)

protected:




private: 


  StdSelect_TypeOfFace mytype;


};







#endif // _StdSelect_FaceFilter_HeaderFile
