// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _StepData_DescrProtocol_HeaderFile
#define _StepData_DescrProtocol_HeaderFile

#include <Standard.hxx>
#include <Standard_DefineHandle.hxx>
#include <Handle_StepData_DescrProtocol.hxx>

#include <TCollection_AsciiString.hxx>
#include <StepData_FileProtocol.hxx>
#include <Standard_CString.hxx>


//! A DescrProtocol is a protocol dynamically (at execution time)
//! defined with :
//! - a list of resources (inherits FileProtocol)
//! - a list of entity descriptions
//! i.e. it can be defined with only C++ writing to initialize it
//! Its initialization must :
//! - set its schema name
//! - define its resources (which can also be other DescrProtocol)
//! - define its entity descriptions
//! - record it in the system by calling RecordLib
class StepData_DescrProtocol : public StepData_FileProtocol
{

public:

  
  Standard_EXPORT StepData_DescrProtocol();
  
  //! Defines a specific Schema Name for this Protocol
  Standard_EXPORT   void SetSchemaName (const Standard_CString name) ;
  
  //! Records this Protocol in the service libraries, with a
  //! DescrGeneral and a DescrReadWrite
  //! Does nothing if the Protocol brings no proper description
  Standard_EXPORT   void LibRecord()  const;
  
  //! Returns the Schema Name attached to each class of Protocol
  //! here, returns the SchemaName set by SetSchemaName
  //! was C++ : return const
  Standard_EXPORT virtual   Standard_CString SchemaName()  const;




  DEFINE_STANDARD_RTTI(StepData_DescrProtocol)

protected:




private: 


  TCollection_AsciiString thename;


};







#endif // _StepData_DescrProtocol_HeaderFile
