// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _Sweep_NumShapeTool_HeaderFile
#define _Sweep_NumShapeTool_HeaderFile

#include <Standard.hxx>
#include <Standard_DefineAlloc.hxx>
#include <Standard_Macro.hxx>

#include <Sweep_NumShape.hxx>
#include <Standard_Integer.hxx>
#include <TopAbs_ShapeEnum.hxx>
#include <TopAbs_Orientation.hxx>
#include <Standard_Boolean.hxx>
class Standard_OutOfRange;
class Sweep_NumShape;


//! This class provides  the indexation and  type analysis
//! services required by  the NumShape Directing Shapes of
//! Swept Primitives.
class Sweep_NumShapeTool 
{
public:

  DEFINE_STANDARD_ALLOC

  
  //! Create a new NumShapeTool with <aShape>.  The Tool
  //! must prepare an indexation  for  all the subshapes
  //! of this shape.
  Standard_EXPORT Sweep_NumShapeTool(const Sweep_NumShape& aShape);
  
  //! Returns the number of subshapes in the shape.
  Standard_EXPORT   Standard_Integer NbShapes()  const;
  
  //! Returns the index of <aShape>.
  Standard_EXPORT   Standard_Integer Index (const Sweep_NumShape& aShape)  const;
  
  //! Returns the Shape at index anIndex
  Standard_EXPORT   Sweep_NumShape Shape (const Standard_Integer anIndex)  const;
  
  //! Returns the type of <aShape>.
  Standard_EXPORT   TopAbs_ShapeEnum Type (const Sweep_NumShape& aShape)  const;
  
  //! Returns the orientation of <aShape>.
  Standard_EXPORT   TopAbs_Orientation Orientation (const Sweep_NumShape& aShape)  const;
  
  //! Returns true if there is a First Vertex in the Shape.
  Standard_EXPORT   Standard_Boolean HasFirstVertex()  const;
  
  //! Returns true if there is a Last Vertex in the Shape.
  Standard_EXPORT   Standard_Boolean HasLastVertex()  const;
  
  //! Returns the first vertex.
  Standard_EXPORT   Sweep_NumShape FirstVertex()  const;
  
  //! Returns the last vertex.
  Standard_EXPORT   Sweep_NumShape LastVertex()  const;




protected:





private:



  Sweep_NumShape myNumShape;


};







#endif // _Sweep_NumShapeTool_HeaderFile
