// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _TopCnx_EdgeFaceTransition_HeaderFile
#define _TopCnx_EdgeFaceTransition_HeaderFile

#include <Standard.hxx>
#include <Standard_DefineAlloc.hxx>
#include <Standard_Macro.hxx>

#include <TopTrans_CurveTransition.hxx>
#include <Standard_Integer.hxx>
#include <Standard_Real.hxx>
#include <TopAbs_Orientation.hxx>
class gp_Dir;


//! TheEdgeFaceTransition is an algorithm to   compute
//! the  cumulated  transition for interferences on an
//! edge.
class TopCnx_EdgeFaceTransition 
{
public:

  DEFINE_STANDARD_ALLOC

  
  //! Creates an empty algorithm.
  Standard_EXPORT TopCnx_EdgeFaceTransition();
  
  //! Initialize  the     algorithm    with the    local
  //! description of the edge.
  Standard_EXPORT   void Reset (const gp_Dir& Tgt, const gp_Dir& Norm, const Standard_Real Curv) ;
  
  //! Initialize the algorithm with a linear Edge.
  Standard_EXPORT   void Reset (const gp_Dir& Tgt) ;
  
  //! Add a curve  element to the  boundary.  Or  is the
  //! orientation of   the interference on  the boundary
  //! curve. Tr is  the transition  of the interference.
  //! BTr     is   the    boundary  transition    of the
  //! interference.
  Standard_EXPORT   void AddInterference (const Standard_Real Tole, const gp_Dir& Tang, const gp_Dir& Norm, const Standard_Real Curv, const TopAbs_Orientation Or, const TopAbs_Orientation Tr, const TopAbs_Orientation BTr) ;
  
  //! Returns the current cumulated transition.
  Standard_EXPORT   TopAbs_Orientation Transition()  const;
  
  //! Returns the current cumulated BoundaryTransition.
  Standard_EXPORT   TopAbs_Orientation BoundaryTransition()  const;




protected:





private:



  TopTrans_CurveTransition myCurveTransition;
  Standard_Integer nbBoundForward;
  Standard_Integer nbBoundReversed;


};







#endif // _TopCnx_EdgeFaceTransition_HeaderFile
