// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _TopOpeBRepDS_ShapeShapeInterference_HeaderFile
#define _TopOpeBRepDS_ShapeShapeInterference_HeaderFile

#include <Standard.hxx>
#include <Standard_DefineHandle.hxx>
#include <Handle_TopOpeBRepDS_ShapeShapeInterference.hxx>

#include <Standard_Boolean.hxx>
#include <TopOpeBRepDS_Config.hxx>
#include <TopOpeBRepDS_Interference.hxx>
#include <TopOpeBRepDS_Kind.hxx>
#include <Standard_Integer.hxx>
#include <Standard_OStream.hxx>
class TopOpeBRepDS_Transition;


//! Interference
class TopOpeBRepDS_ShapeShapeInterference : public TopOpeBRepDS_Interference
{

public:

  
  //! a shape interfers on shape <G> with shape <S>.
  //! examples :
  //! create a ShapeShapeInterference describing :
  //! vertex V of edge E1 found on edge E2 :
  //! ST,S,GT,G = TopOpeBRepDS_EDGE,E2,TopOpeBRepDS_VERTEX,V
  //!
  //! create a ShapeShapeInterference describing
  //! vertex V of edge E found on face F :
  //! ST,S,GT,G = TopOpeBRepDS_FACE,F,TopOpeBRepDS_VERTEX,V
  //!
  //! <GBound> indicates if shape <G> is a bound of shape <S>.
  //!
  //! <SCC> :
  //! UNSH_GEOMETRY :
  //! <S> and <Ancestor> have any types,
  //! <S> and <Ancestor> don't share the same geometry
  //! SAME_ORIENTED :
  //! <S> and <Ancestor> have identical types,
  //! <S> and <Ancestor> orientations are IDENTICAL.
  //! DIFF_ORIENTED :
  //! <S> and <Ancestor> have identical types,
  //! <S> and <Ancestor> orientations are DIFFERENT.
  Standard_EXPORT TopOpeBRepDS_ShapeShapeInterference(const TopOpeBRepDS_Transition& T, const TopOpeBRepDS_Kind ST, const Standard_Integer S, const TopOpeBRepDS_Kind GT, const Standard_Integer G, const Standard_Boolean GBound, const TopOpeBRepDS_Config C);
  
  Standard_EXPORT   TopOpeBRepDS_Config Config()  const;
  
  Standard_EXPORT   Standard_Boolean GBound()  const;
  
  Standard_EXPORT   void SetGBound (const Standard_Boolean b) ;
  
  Standard_EXPORT virtual   Standard_OStream& Dump (Standard_OStream& OS)  const;




  DEFINE_STANDARD_RTTI(TopOpeBRepDS_ShapeShapeInterference)

protected:




private: 


  Standard_Boolean myGBound;
  TopOpeBRepDS_Config myC;


};







#endif // _TopOpeBRepDS_ShapeShapeInterference_HeaderFile
