// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _Vrml_DirectionalLight_HeaderFile
#define _Vrml_DirectionalLight_HeaderFile

#include <Standard.hxx>
#include <Standard_DefineAlloc.hxx>
#include <Standard_Macro.hxx>

#include <Standard_Boolean.hxx>
#include <Standard_Real.hxx>
#include <Quantity_Color.hxx>
#include <gp_Vec.hxx>
#include <Standard_OStream.hxx>
class Quantity_Color;
class gp_Vec;


//! defines a directional  light node of VRML specifying
//! properties of lights.
//! This  node  defines  a  directional  light  source  that  illuminates
//! along  rays  parallel  to  a  given  3-dimentional  vector
//! Color is  written  as  an  RGB  triple.
//! Light intensity must be in the range 0.0 to 1.0, inclusive.
class Vrml_DirectionalLight 
{
public:

  DEFINE_STANDARD_ALLOC

  
  Standard_EXPORT Vrml_DirectionalLight();
  
  Standard_EXPORT Vrml_DirectionalLight(const Standard_Boolean aOnOff, const Standard_Real aIntensity, const Quantity_Color& aColor, const gp_Vec& aDirection);
  
  Standard_EXPORT   void SetOnOff (const Standard_Boolean aOnOff) ;
  
  Standard_EXPORT   Standard_Boolean OnOff()  const;
  
  Standard_EXPORT   void SetIntensity (const Standard_Real aIntensity) ;
  
  Standard_EXPORT   Standard_Real Intensity()  const;
  
  Standard_EXPORT   void SetColor (const Quantity_Color& aColor) ;
  
  Standard_EXPORT   Quantity_Color Color()  const;
  
  Standard_EXPORT   void SetDirection (const gp_Vec& aDirection) ;
  
  Standard_EXPORT   gp_Vec Direction()  const;
  
  Standard_EXPORT   Standard_OStream& Print (Standard_OStream& anOStream)  const;




protected:





private:



  Standard_Boolean myOnOff;
  Standard_Real myIntensity;
  Quantity_Color myColor;
  gp_Vec myDirection;


};







#endif // _Vrml_DirectionalLight_HeaderFile
