// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _XSAlgo_AlgoContainer_HeaderFile
#define _XSAlgo_AlgoContainer_HeaderFile

#include <Standard.hxx>
#include <Standard_DefineHandle.hxx>
#include <Handle_XSAlgo_AlgoContainer.hxx>

#include <Handle_XSAlgo_ToolContainer.hxx>
#include <MMgt_TShared.hxx>
#include <Standard_Real.hxx>
#include <Standard_CString.hxx>
#include <Handle_Standard_Transient.hxx>
#include <Handle_Message_ProgressIndicator.hxx>
#include <Standard_Boolean.hxx>
#include <Handle_Transfer_TransientProcess.hxx>
#include <Standard_Integer.hxx>
#include <Handle_Transfer_FinderProcess.hxx>
class XSAlgo_ToolContainer;
class TopoDS_Shape;
class Standard_Transient;
class Message_ProgressIndicator;
class TopoDS_Edge;
class TopoDS_Face;
class Transfer_TransientProcess;
class Transfer_FinderProcess;



class XSAlgo_AlgoContainer : public MMgt_TShared
{

public:

  
  //! Empty constructor
  Standard_EXPORT XSAlgo_AlgoContainer();
  
  //! Sets ToolContainer
      void SetToolContainer (const Handle(XSAlgo_ToolContainer)& TC) ;
  
  //! Returns ToolContainer
      Handle(XSAlgo_ToolContainer) ToolContainer()  const;
  
  //! Performs actions necessary for preparing environment
  //! for transfer. Empty in Open version.
  Standard_EXPORT virtual   void PrepareForTransfer()  const;
  
  //! Does shape processing with specified tolerances
  //! and returns resulting shape and associated information
  //! in the form of Transient.
  //! This information should be later transmitted to
  //! MergeTransferInfo in order to be recorded in the
  //! translation map
  Standard_EXPORT virtual   TopoDS_Shape ProcessShape (const TopoDS_Shape& shape, const Standard_Real Prec, const Standard_Real MaxTol, const Standard_CString rscfile, const Standard_CString seq, Handle(Standard_Transient)& info, const Handle(Message_ProgressIndicator)& progress = 0)  const;
  
  //! Checks quality of pcurve of the edge on the given face,
  //! and corrects it if necessary.
  Standard_EXPORT virtual   Standard_Boolean CheckPCurve (const TopoDS_Edge& edge, const TopoDS_Face& face, const Standard_Real preci, const Standard_Boolean isSeam)  const;
  
  Standard_EXPORT virtual   void MergeTransferInfo (const Handle(Transfer_TransientProcess)& TP, const Handle(Standard_Transient)& info, const Standard_Integer startTPitem = 1)  const;
  
  //! Updates translation map (TP or FP) with information
  //! resulting from ShapeProcessing
  //! Parameter startTPitem can be used for optimisation, to
  //! restrict modifications to entities stored in TP starting
  //! from item startTPitem
  Standard_EXPORT virtual   void MergeTransferInfo (const Handle(Transfer_FinderProcess)& FP, const Handle(Standard_Transient)& info)  const;




  DEFINE_STANDARD_RTTI(XSAlgo_AlgoContainer)

protected:




private: 


  Handle(XSAlgo_ToolContainer) myTC;


};


#include <XSAlgo_AlgoContainer.lxx>





#endif // _XSAlgo_AlgoContainer_HeaderFile
